#!/bin/sh
if [ $# -lt 2 ]; then
  echo "Usage: $0 report.jasper report.pdf [parameters | -DparamsFile=filename]"
  exit 1
fi

BASEDIR=/usr/local/opmon/share/reports/bin
libpath=$BASEDIR/libs/

for j in ${libpath}/*.jar; do
  export CLASSPATH=${CLASSPATH}:$j
done

thisDir=${0%/*}
export CLASSPATH=${CLASSPATH}:${thisDir}
reportfile=$1
outputfile=$2
shift
shift
params=$*
echo "Jasper File: $reportfile"
echo "Output File: $outputfile"
echo "Report Parameters: $params"
/usr/bin/java -Xms512m -Xmx1G -XX:+UseConcMarkSweepGC -XX:-UseGCOverheadLimit -Dlog4j.configuration=log4j.properties -Djava.awt.headless=true $params JReportRunner "$reportfile" "$outputfile"
