function showMoreOptions()
{
	var elem = Ext.get('moreoptions');
	
	if (elem.dom.style.display == 'none') {
		elem.fadeIn();
		elem.dom.style.display = 'block';
		elem = Ext.get('moreoptionsbutton');
		elem.dom.innerHTML = "<font size='2'>"+langArray['Hide options']+"...</font>";
		
	} else {
		elem.fadeOut({
			useDisplay: true,
			callback: function() {
				elem.dom.style.display = 'none';
			}
		});
		var bt = Ext.get('moreoptionsbutton');
		bt.dom.innerHTML = "<font size='2'>"+langArray['Advanced']+"...</font>";
	}
	
}

function verifyPeriod()
{
	var selectedPeriod = Ext.get('reportPeriod').dom.value;
	var lastFields = Ext.get('lastselect');	
	
	if (selectedPeriod == 'last')  {
		hide("cal0");
		hide("cal1");
		show("lastselect","table-row");
	} else if(selectedPeriod == 'custom') {
		var showMode = "table-row"
		if (Ext.isIE)
			showMode = "block";
					
		show("cal0",showMode);
		show("cal1",showMode);
		hide("lastselect");
	} else {
		hide("cal0");
		hide("cal1");
		hide("lastselect");
	}
}

function show( id,disp ) {
	var obj = Ext.get(id);
	obj.fadeIn();
	obj.dom.style.display = disp;	
}

function hide( id ) {
	var obj = Ext.get(id);
	obj.fadeOut( {
		useDisplay: true,
		callback: function() {
			obj.dom.style.display = 'none';
		}
	});	
}

function changeObjectType()
{
	var elem = Ext.get("objecttypeselect").dom.value;
	
	clearSelects();
	var hiddendiv = Ext.get("hostsdiv");
	var inftable = Ext.get("inferiortable");
	var toField = "";
	if (elem == SERVICE) {
		hiddendiv.fadeIn();
		hiddendiv.dom.style.display = 'block';
		inftable.dom.style.height = "307px";
		Ext.get('step-id').dom.innerHTML = '3.';
		toField = "previous-hostselect";
	} else {
		hiddendiv.fadeOut( {
			useDisplay: true,
			callback: function() {
				hiddendiv.dom.style.display = 'none';
				inftable.dom.style.height = "400px";
				Ext.get('step-id').dom.innerHTML = '2.';
			}
		});
		toField = "hostselect";
	}

	getHosts(elem,toField);
	updateHiddenField();
}

function getHosts(objectType,toField)
{
	
	var action = '';

	switch(objectType) {
	
	case(SERVICE):
	case(HOST):
		action = 'gethosts';
		break;
		
	case(HOSTGROUP):
		action = 'gethostgroups';
		break;
		
	case(SERVICEGROUP):
		action = 'getservicegroups';
		break;
		
	case(SERVICECATALOG):
		action = 'getservicecatalogs';
		break;
	
	default:
		action = 'gethostgroups';
		break;
		
	}
	
	
	Ext.Ajax.request({
		url: '/opmon/seagull/www/index.php/opreports/action/'+action+'/?',
		method:	'get',
		success: function( result, request ) {
			
			var selectField = Ext.get(toField);
			var i;
			
			for(i=selectField.dom.options.length-1;i>=0;i--) {
				selectField.dom.remove(i);
			}
			
			selectField.dom.disabled = false;	
			var hosts = eval('('+result.responseText+')');
			var host;
			for(id in hosts) {
				var opt = document.createElement("OPTION");
				opt.value = id;
				opt.text = hosts[id];
				selectField.dom.options.add(opt);
			}
			
			if (objectType == SERVICE)
				getServices();
		}
	});

}

function getServices()
{

	var select = Ext.get('previous-hostselect');
	if (select.dom.options.selectedIndex == -1)
		return true;

	var host_id = select.dom.value;
		
	Ext.Ajax.request({
		url: '/opmon/seagull/www/index.php/opreports/action/getservices/?',
		method:	'post',
		params:	{
			host_id: host_id
		},
		success: function( result, request ) {
			
			var selectField = Ext.get('hostselect');
			var i;
			
			for(i=selectField.dom.options.length-1;i>=0;i--) {
				selectField.dom.remove(i);
			}
			
			selectField.dom.disabled = false;
			var services = eval('('+result.responseText+')');
			var service;
			for(id in services) {
				var opt = document.createElement("OPTION");
				opt.value = id;
				opt.text = services[id];
				selectField.dom.options.add(opt);
			}
		}
	});
}

/**
 * Move all options from one select to another
 */
function moveAllOptions(from_id,to_id)
{	
	var select = Ext.get(from_id);
	while(select.dom.length != 0) {
		select.dom.options[0].selected = true;
		moveOption(from_id,to_id);
	}
}

/**
 * Move one option from one select to another
 */
function moveOption(from_id, to_id)
{
	var from = Ext.get(from_id);
	var to = Ext.get(to_id);
	var hiddenField = Ext.get("hiddenObjectType");

	if (from.dom.options.selectedIndex == -1)
		return true;

	var fromOption = from.dom.options[from.dom.options.selectedIndex];
	
	/*
	 * we have a different behaviour when treating
	 * service selection. We need to concatenate
	 * hostname with servicedescription at select
	 * field
	 */
	if (hiddenField.dom.value == SERVICE && to_id == 'selecteditens') {
		
		var hostSelect = Ext.get('previous-hostselect').dom;
		var hostName = hostSelect.options[hostSelect.options.selectedIndex].text;		
		var text = hostName+"!"+fromOption.text;
		var newOption = new Option(text, fromOption.value);
		to.dom.options.add(newOption);
		to.dom.disabled = false;
	
	/*
	 * we need to take off the hostname from select option
	 */
	} else if (hiddenField.dom.value == SERVICE && to_id == 'hostselect') {
		
		var oldTxt = from.dom.options[from.dom.options.selectedIndex].text;
		var oldValue = from.dom.options[from.dom.options.selectedIndex].value;
		var reg = /(.+)!(.+)/;
		var parse = reg.exec(oldTxt);
		var txt = parse[2];

		parse = reg.exec(oldValue);
		var hostid = parse[1];
		var serviceid = parse[2];

		var selectedHost = Ext.get('previous-hostselect').dom.value;
		
		if (hostid == selectedHost) {		
			var newOption = new Option(txt, fromOption.value);
			to.dom.options.add(newOption);
			to.dom.disabled = false;
		}
		
	} else {
		// create an Option like his own image
		var newOption = new Option(fromOption.text, fromOption.value);
		to.dom.options.add(newOption);
		to.dom.disabled = false;
	}

	from.dom.remove(from.dom.options.selectedIndex);	
}

/**
 * Emtpy all interface select fields
 */
function clearSelects()
{
	var select = Ext.get("hostselect");
	var select2 = Ext.get("selecteditens");
	for(i=select.dom.options.length-1;i>=0;i--) {
		select.dom.remove(i);
	}
	for(i=select2.dom.options.length-1;i>=0;i--) {
		select2.dom.remove(i);
	}	
}

/**
 * Select the needed options and submit the main
 * form
 */
function submitForm()
{
	var select = Ext.get("selecteditens");	
	var i;
	
	for(i=select.dom.options.length-1;i>=0;i--) {
		select.dom.options[i].selected = true;
	}
	
	document.mainForm.submit();
}

function updateHiddenField()
{
	var fakeField = Ext.get("objecttypeselect");
	var hiddenField = Ext.get("hiddenObjectType");

	hiddenField.dom.value = fakeField.dom.value;
}

function prepareFilter(str)
{
	mainForm.applyFilter(str);
}

function prepareFilter(str)
{
	document.mainEmbed.applyFilter(str);
	var obj = parent.document.getElementById('filterString');
	var btn = parent.document.getElementById('cancelSearch');

	if (obj.value.length && btn) {                                                                                                                   
	    obj.className += " filter-active";                                                                                                                                                                                                                                                                 
            btn.src = btn.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");                                                  
            btn.style.cursor = "pointer";                                                                                                       
        }            	
}

function cancelSearch() {
    var obj = parent.document.getElementById('filterString');
    var btn = parent.document.getElementById('cancelSearch');
    if (obj && btn) {
        obj.className = "filter-content-text-input row";
	obj.value = "";
	btn.src = btn.src.replace("ico-cancela-busca.","ico-cancela-busca-disabled.");
	btn.style.cursor = "";
	document.mainEmbed.applyFilter("");
    }
}