const testHelpers = (
    function() {

        // trace :: String, Value -> Value
        const trace = R.curry(function(tag, x) {
            console.log(tag, x);
            return x;
        });

        // breakArr :: Number, Array -> Array
        const breakArr = R.curry((x, arr) => {
            return  arr.reduce((prev, curr) => {
                    const head = R.head(prev)
                    const tail = R.tail(prev)

                    if (R.length(head) < x) return [ [...head, curr], ...tail  ]
                    return [ [curr], head, ...tail  ]
            }, [[]])
        })

        return {
            trace: trace,
            breakArr: breakArr
        }

    }
)();
