'use strict';

(function(g) {
    const data = { "state":0, "data":{}, "execution_time":0, "host_id":"7", "service_id":"1198", "date":"02:32", "host_n ame":"dummy", "service_description":"Uptime" }

    // metric :: Number -> Object
    const metric = R.curry(
        function(x, staticMetrics) {
            const boilerplate  = { "metric":"", "value":"", "unit":"", "warning":"", "critical":"", "min":"", "max":"" };
            const m            = R.clone(boilerplate); 
            m.metric = staticMetrics[x || 0];

            return m;
        }
    )

    // generateDiffMetrics :: Number, Array -> Object
    const generateDiffMetrics = R.curry(
        function(staticMetrics) {
            const max = staticMetrics.length
            return (
                function rec(i, obj) {
                    const freshMetric = metric( randomValue(staticMetrics.length), staticMetrics )
                    if (i >= max) return obj
                    if (obj.hasOwnProperty( freshMetric.metric )) return rec(i, obj)
                    obj[freshMetric.metric] = freshMetric
                    return rec(R.inc(i), obj)
                }
            )(0, {})
        }
    )

    // generateServiceCheck :: Object -> Object
    const generateServiceCheck = R.curry(
        function(metrics) {
            var jayson = R.clone(data)
            var fresh = Object.keys(metrics).reduce((prev, key) => {
                prev[ metrics[key].metric ]       = R.clone(metrics[key])
                prev[ metrics[key].metric ].value = randomValue(5) + 1; // value gerado aleatorio de 1 a 5
                return prev
            }, {});
            jayson["data"] = fresh
            return jayson
        }
    )

    // generateTimeLine :: Object -> Array
    const generateTimeLine = R.curry(
        function(metrics) {
            return (
                function recursive(i, arr) {
                    if(i >= 50) return arr
                    return recursive(R.inc(i), [ ...arr, generateServiceCheck(metrics) ])
                }
            )(0, [])
        }
    )

    function randomValue(max) {
        return Math.floor( (Math.random() * max) )
    }

    g.metricTimeline = R.compose(generateTimeLine, generateDiffMetrics)
    g.generateServiceCheck = R.compose(generateServiceCheck, generateDiffMetrics)

})(window.helpers);
