Ext.define('Ext.app.Dashboard',{
    extend: 'Ext.panel.Panel',
    alias: 'widget.portalpanel',    
    cls: 'grid-stack-panel',
    autoScroll: true,
    dashboardData: null,
    elements: [],
    initComponent: function () {
        //this.layout = {
        //    type : 'absolute'
        //};
        this.callParent();        
    },
    items: [{
        xtype: 'container',
        id: 'detailed_grid',
        cls: 'grid-stack grid-stack-3'
    }],
    setDashboardData: function(d) {
        this.dashboardData = d;
        if(this.isVisible()) {
            this.renderDashboardData();
        }
    },
    renderDashboardData: function() {
        this.child().removeAll(true);
        Ext.ComponentQuery.query('portlet').forEach(function(el){el.destroy();});
        var grid = $('.grid-stack').data('gridstack');
        if (this.dashboardData && grid) {
            var data = GridStackUI.Utils.sort(this.dashboardData);

            grid.remove_all();

            var i, panel;

            var item_x = 0, item_y = -1;

            var detailed_grid = Ext.getCmp('detailed_grid');

            for (i in data) {
                item_x = (i%3);
                if (item_x === 0 ){
                    item_y++;
                }
                var node = data[i];

                var item = this.child().getEl().createChild({
                    tag: 'div',
                    cls: 'grid-stack-item',  
                    'data-id': 'parent-portlet-'+node.id,
                    id: 'parent-portlet-'+node.id,
                    children: [
                        {tag: 'div',cls: 'grid-stack-item-content', id: 'item-content-'+node.id}
                    ]
                });  

                //var item = $('<div class="grid-stack-item" data-id="parent-portlet-'+node.id+'" id="parent-portlet-'+node.id+'"><div class="grid-stack-item-content" id="item-content-'+node.id+'"/>');

                grid.add_widget(item.dom, item_x, item_y, node.width, node.height);

                panel = Ext.create('Ext.app.Portlet',{
                    itemId: 'portlet-' + node.id,
                    title: node.title,
                    renderTo: item.first()
                });

                AmCharts.makeChart(panel.id+'-body',node.chart);    
            }            
        }    
    },
    listeners: {
        render: function() {
            $('.grid-stack').gridstack({
                min_width: 640,
                width: 3,
                always_show_resize_handle: /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent),
                resizable: {
                    handles: 'e, se, s, sw, w'
                }
            });            
            $('.grid-stack').on('resizestop', function (event, ui) {
                setTimeout(function(){
                    var p = Ext.getCmp(event.target.firstChild.lastChild.id);
                    p.doLayout();
                    var chart = AmCharts.getChartById(p.id+'-body');
                    chart.validateSize();
                },100);

            });  

            $('.grid-stack').on('dragstart', function (event, ui) {
                var grid = this;
                var element = event.target;
            });
        },
        show: function() {                               
            this.renderDashboardData(); 
        },
        resize: function() {
            Ext.defer(function(){Ext.ComponentQuery.query('portlet').forEach(function(el){el.doLayout();});},50);
        }           
    }
});