Ext.define('Op.Reports.Utils', {
    extend: 'Ext.Base',
    singleton: true,
    shadeBlend: function (p,c0,c1) {
        var n=p<0?p*-1:p,u=Math.round,w=parseInt,f,t;
        if(c0.length>7){
            f = c0.split(",");t=(c1?c1:p<0?"rgb(0,0,0)":"rgb(255,255,255)").split(",");var R=w(f[0].slice(4)),G=w(f[1]),B=w(f[2]);
            return "rgb("+(u((w(t[0].slice(4))-R)*n)+R)+","+(u((w(t[1])-G)*n)+G)+","+(u((w(t[2])-B)*n)+B)+")";
        } else{
            f = w(c0.slice(1),16);t=w((c1?c1:p<0?"#000000":"#FFFFFF").slice(1),16);var R1=f>>16,G1=f>>8&0x00FF,B1=f&0x0000FF;
            return "#"+(0x1000000+(u(((t>>16)-R1)*n)+R1)*0x10000+(u(((t>>8&0x00FF)-G1)*n)+G1)*0x100+(u(((t&0x0000FF)-B1)*n)+B1)).toString(16).slice(1);
        }
    },
    clone: function(obj) {
        return Ext.apply({},{},obj);
    },
    Base64: {
        base64s : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",
        encode: function(decStr){
            if (typeof btoa === 'function') {
                return btoa(decStr);            
            }
            var base64s = this.base64s;
            var bits;
            var dual;
            var i = 0;
            var encOut = "";
            while(decStr.length >= i + 3){
                bits = (decStr.charCodeAt(i++) & 0xff) <<16 | (decStr.charCodeAt(i++) & 0xff) <<8 | decStr.charCodeAt(i++) & 0xff;
                encOut += base64s.charAt((bits & 0x00fc0000) >>18) + base64s.charAt((bits & 0x0003f000) >>12) + base64s.charAt((bits & 0x00000fc0) >> 6) + base64s.charAt((bits & 0x0000003f));
            }
            if(decStr.length -i > 0 && decStr.length -i < 3){
                dual = Boolean(decStr.length -i -1);
                bits = ((decStr.charCodeAt(i++) & 0xff) <<16) |    (dual ? (decStr.charCodeAt(i) & 0xff) <<8 : 0);
                encOut += base64s.charAt((bits & 0x00fc0000) >>18) + base64s.charAt((bits & 0x0003f000) >>12) + (dual ? base64s.charAt((bits & 0x00000fc0) >>6) : '=') + '=';
            }
            return(encOut);
        },    
        decode: function(encStr){
            if (typeof atob === 'function') {
                return atob(encStr); 
            }
            var base64s = this.base64s;        
            var bits;
            var decOut = "";
            var i = 0;
            for(; i<encStr.length; i += 4){
                bits = (base64s.indexOf(encStr.charAt(i)) & 0xff) <<18 | (base64s.indexOf(encStr.charAt(i +1)) & 0xff) <<12 | (base64s.indexOf(encStr.charAt(i +2)) & 0xff) << 6 | base64s.indexOf(encStr.charAt(i +3)) & 0xff;
                decOut += String.fromCharCode((bits & 0xff0000) >>16, (bits & 0xff00) >>8, bits & 0xff);
            }
            if(encStr.charCodeAt(i -2) == 61){
                return(decOut.substring(0, decOut.length -2));
            }
            else if(encStr.charCodeAt(i -1) == 61){
                return(decOut.substring(0, decOut.length -1));
            }
            else {
                return(decOut);
            }
        }        
    },
    Date: {
        duration: function(time,inMinutes) {
            inMinutes = inMinutes || false;

            var days = 0,hours = 0,minutes = 0,seconds = 0;

            if (inMinutes) {
                time *= 60;
            }

            while(time >= 86400 ) {
                days++;
                time -= 86400;
            }

            while(time >= 3600) {
                hours++;
                time -= 3600;
            }

            while (time >= 60) {
                minutes++;
                time -= 60;
            }			
            seconds = time;			
            return days+"d "+hours+"h "+minutes+"m "+seconds+"s";
        }  
    },
    uuid: function() {
        var s4 = function() {
            return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
        };
        return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
    },
    doHttpRequest: function(url, callback, params, parseJson, useLoading) {

        var view = (Ext.getCmp('main_view')) ? Ext.getCmp('main_view') : Ext.getCmp('realtime_view');

        params = params || undefined;
        useLoading = typeof useLoading !== 'undefined' ? useLoading : true;
        if (useLoading) {
            view.setLoading(true);
        }
        if (params) {
            for (var p in params) {
                if (typeof params[p] === 'object') {
                    params[p] = JSON.stringify(params[p]);
                }
            }
        }

        Ext.Ajax.useDefaultXhrHeader = false;
        Ext.Ajax.timeout = 1000000;
        Ext.Ajax.request({
            url: url,
            method: "POST",
            params: params || {},
            success: function(result, request) {
                //   try {
                var o = {};
                parseJson = (typeof parseJson == 'undefined') ? true : parseJson;

                if (parseJson) {
                    o = JSON.parse(result.responseText);
                } else {
                    o = result.responseText;
                }

               	if (callback) {
               	    	callback(o);
               	}
                view.setLoading(false);
            },
            failure: function(result, request) {
                view.setLoading(false);
            }
        });
    },

    getElements: function(action, callback, params) {
        Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/'+action,function(o) {
            var d = [];
            if (o.hasOwnProperty('base_array')) {
                o = o.base_array;
            }
            for (var i in o) {
                d.push({name: i, value: o[i]});
            }
            callback(d);
        },params);
    }
});


function prepareFilter(str)
{
    try{
        var controller = Reports.getApplication().getController('MainController');
        controller.applyFilter(str);
        var obj = parent.document.getElementById('filterString');
        var btn = parent.document.getElementById('cancelSearch');

        if (obj.value.length && btn) {                                                                                                                   
            obj.className += " filter-active";                                                                                                                                                                                                                                                                 
            btn.src = btn.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");                                                  
            btn.style.cursor = "pointer";                                                                                                       
        }   
    } catch(e) {
        console.log(e);
    }
}

function cancelSearch() {
    try {
        var controller = Reports.getApplication().getController('MainController');
        var obj = parent.document.getElementById('filterString');
        var btn = parent.document.getElementById('cancelSearch');
        if (obj && btn) {
            obj.className = "filter-content-text-input row";
            obj.value = "";
            btn.src = btn.src.replace("ico-cancela-busca.","ico-cancela-busca-disabled.");
            btn.style.cursor = "";
            controller.applyFilter("");
        }
    } catch(e) {
        console.log(e);
    }    
}

function castBooleanToString (value) {
    return value + 0 + "";
}
