/*
 * File: app/controller/DefaultController.js
 *
 * This file was generated by Sencha Architect version 4.2.4.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Reports.controller.DefaultController', {
    extend: 'Ext.app.Controller',

    onOverviewPagingChange: function(pagingtoolbar, pageData, eOpts) {
        if (pageData) {
            Ext.app.Config.originalReportOptions = undefined;
            var item = Ext.getStore('service_paging').getAt(0).raw;
            item.pagingChange = true;
            this.loadOverviewContent(item);
        }
    },

    onLegendPanelButtonToggleClick: function(button, e, eOpts) {
        var legend_column = Ext.query('.legend-btn');
        Ext.each(legend_column, function(elem){
            elem = Ext.getCmp(elem.id);
            if (button.pressed === elem.pressed) {
                elem.toggle();
            }
        });
    },

    onLegendPanelButtonThresholdsClick: function(button, e, eOpts) {
        var graphic_container = Ext.getCmp('graphic_container');
        var chart = graphic_container.chart;
        chart.setThresholdsGuide(button.pressed);
    },

    onLegendPanelButtonAutoscaleClick: function(button, e, eOpts) {
        var graphic_container = Ext.getCmp('graphic_container');
        var chart = graphic_container.chart;
        chart.setAutoScale(button.pressed);
    },

    onPeriodReportCollapse: function(combobox) {
        var value = combobox.getValue();
        if (combobox.id == 'tabular_period_field_report') {
            Ext.getCmp('period_field_report').setValue(value);
        }

        if (value == 'custom' || value == 'last') {
            var config = Ext.app.Config.getOptions();
            Ext.create('Reports.view.PeriodWindow');
            Ext.getCmp('period_form_container_window').getForm().setValues(config);
            if (value == 'custom') {
                Ext.getCmp("period_from_report").show();
                Ext.getCmp("period_to_report").show();
                Ext.getCmp("period_last_report").hide();
            } else {
                Ext.getCmp("period_last_report").show();
                Ext.getCmp("period_from_report").hide();
                Ext.getCmp("period_to_report").hide();
            }
        } else {
            Ext.app.Config.setOptions(Ext.getCmp('graphic_report_settings').getForm().getValues());
            this.reloadContent();
        }
    },

    onReportPeriodWindowButtonClick: function(button, e, eOpts) {
        Ext.app.Config.setOptions(Ext.getCmp('graphic_report_settings').getForm().getValues());
        Ext.app.Config.setOptions(Ext.getCmp('period_form_container_window').getForm().getValues());
        this.reloadContent();
    },

    onTabularContentShow: function(target) {
        //console.log('tabular_show');
        this.loadTabularContent();
    },

    onOverviewHeaderDescriptionChange: function(field, newValue, oldValue, eOpts) {
        if (newValue !== ""){
            field.show();
        } else {
            field.hide();
        }
    },

    onCustomCardShow: function(component, eOpts) {
        this.loadCustomContent();
    },

    onOverviewContentShow: function(component, eOpts) {
        //console.log('content show');
    },

    onOverviewBtnToggle: function(button, pressed, eOpts) {
        var state_enabled,state_disabled;
        if (button.id == 'detailed_btn') {
            s_enabled = 'detailed';
            s_disabled = 'overview';
        } else {
            s_enabled = 'overview';
            s_disabled = 'detailed';
        }

        if (pressed) {
            Ext.getCmp(s_disabled+'_btn').toggle(!pressed,true);
            Ext.getCmp('graphic_card').layout.setActiveItem(s_enabled+'_tab');
        } else {
            Ext.getCmp(s_enabled+'_btn').toggle(!pressed,true);
        }
    },

    loadOverviewContent: function(item) {
        var me = this;
        var graphic_container = Ext.getCmp('graphic_container');

        var config = Ext.app.Config.getOptions();
        config.selectedItens = [item.value];
        config.objectType = Ext.app.Config.SERVICE;
        Ext.app.Config.setOptions({currentSelectedItem: item.value});

        var fconfig = Ext.clone(config);
        fconfig.host_name = item.host_name;
        fconfig.service_description = item.service_description;
        fconfig.current_period = '';
        fconfig.current_duration = '';
        Ext.getCmp('graphic_report_settings').getForm().reset();
        Ext.getCmp('graphic_report_settings').getForm().setValues(fconfig);

        Ext.getCmp('overview_period_container').getForm().reset();
        Ext.getCmp('overview_period_container').getForm().setValues(fconfig);

        Ext.getCmp('cmb_selected_reports').setValue(
            Ext.getStore('selectedItems').findRecord('value', item.value)
        );

        var max;
        var min;

        var isNotAPagingChange = (! item.pagingChange);

        var gambiToBypassServiceGroupAndHostGroupRequestsToSendPDFByEmail = function () {
            if (Ext.getCmp("email_container").getSelectionModel().getSelection().length > 0 && (! config.aggregatedByMetric)) {
                config.selectedItensDescription = [];
                Ext.getStore('selectedItems').each(function (item){
                    config.selectedItensDescription.push({label: item.get('name'), value: item.get('value')});
                });
            }
        }();

        var success = function(o) {

            if ((o !== undefined) && o.length > 0 && (o[0].cpdata.length > 1)) {

                //plot first service
                var d = o.shift();

                if (!d || !d.cpdata || !d.cpdata.length) {
                    me.setOverviewNoData(true);
                    return;
                }

                me.setOverviewNoData(false);

                var oldChart = graphic_container.chart;

                if (oldChart && oldChart.chart && isNotAPagingChange) {
                    max = oldChart.chart.valueAxesDefault[0].maximum;
                    min = oldChart.chart.valueAxesDefault[0].minimum;
                }

                me.clearOldChart();

                //new chart
                var chart = new Op.Reports.SerialChart({
                    containerId:'graphic_container',
                    maximum: max,
                    minimum: min
                });

                graphic_container.chart = chart;

                if (config.reportType == Ext.app.Config.CPGROUPBY) {
                    chart.setType('column');
                }

                //config paramenters
                var btnAutoScale = Ext.getCmp('legend_panel_button_autoscale').pressed;
                var btnTresholds = Ext.getCmp('legend_panel_button_thresholds').pressed;

                chart.setAutoScale((Number(config.autoScale) || btnAutoScale) ? true : false);
                chart.setThresholdsGuide((Number(config.showThresholdCp) || btnTresholds) ? true : false);

                chart.setPercentilGuide(config.show95Percentil == '1' ? true : false);

                chart.setBaselineGuide(config.baselineTrend == '1' && config.baselineTrendShowAlarms == '1' ? true : false);

                chart.setFutureGuide(config.futureTrend == '1' ? true : false);

                var metricToShow = Ext.app.Config.getOptions().metric;
                if (metricToShow) {
                    d.metric = d.metric.filter(function(x) {
                        return x === metricToShow || x === (metricToShow + "_realistic");
                    });

                    d.cpdata_future_break = d.cpdata_future_break.filter(function(x, i) {
                        return x.metric === metricToShow + "_realistic";
                    });

                    d.cpdata_future_limit = d.cpdata_future_limit.filter(function(x) {
                        return x.metric === metricToShow;
                    });
                }

                chart.setData(d);

                Ext.getCmp('legend_grid_column_perc95').setVisible(chart.getPercentilGuide());
                Ext.getCmp('legend_grid_column_futuretrend').setVisible(chart.getFutureGuide());

                config.host_name = d.host_name;
                config.service_description = d.service_description;

                config.current_period = Ext.Date.format(new Date(d.tsBegin*1000), Ext.app.Config.LONG_DATE_FORMAT)+' '+Ext.locale.translate('to')+' '+Ext.Date.format(new Date(d.tsEnd*1000), Ext.app.Config.LONG_DATE_FORMAT);
                config.current_duration = Op.Reports.Utils.Date.duration(d.tsEnd - d.tsBegin);

                Ext.getCmp('graphic_report_settings').getForm().setValues(config);
                Ext.getCmp('overview_period_container').getForm().setValues(config);

                if (config.futureTrend && config.futureTrend == "1") {
                    //disable realtime zoom
                    chart.enableZoom(true,false);
                } else {
                    chart.enableZoom(true,true);
                }

                if (Ext.app.Config.originalReportOptions) {
                    chart.showZoomOut(true);
                } else {
                    chart.showZoomOut(false);
                }

                chart.onZoomOut(function(){
                    config = Ext.clone(Ext.app.Config.originalReportOptions);
                    Ext.app.Config.originalReportOptions = undefined;
                    var params = {jsonData: config};
                    Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/getcp',success,params);
                });

                chart.onZoomIn(function(evt){
                    if (!Ext.app.Config.originalReportOptions) {
                        Ext.app.Config.originalReportOptions = Ext.clone(config);
                    }

                    if (evt.start && evt.end) {

                        var startDate,endDate;
                        if (config.reportType == Ext.app.Config.CPGROUPBY) {
                            startDate = Date.parse(evt.chart.dataProvider[evt.start].date);
                            endDate = Date.parse(evt.chart.dataProvider[evt.end].date);
                        } else {
                            startDate = evt.start;
                            endDate = evt.end;
                        }

                        config.dateFrom = Ext.Date.format(new Date(startDate), 'd-m-Y');
                        config.timeFrom = Ext.Date.format(new Date(startDate), 'H:i');
                        config.dateTo = Ext.Date.format(new Date(endDate), 'd-m-Y');
                        config.timeTo = Ext.Date.format(new Date(endDate), 'H:i');

                        if (config.dateFrom == config.dateTo && config.timeFrom == config.timeTo) {
                            config.timeTo = "23:59";
                        }

                        if (config.summarizeParams) {
                            config.summarizeParams.period = "custom";
                            config.summarizeParams.param1 = config.dateFrom+" "+config.timeFrom;
                            config.summarizeParams.param2 = config.dateTo+" "+config.timeTo;
                        }

                        config.reportPeriod = 'custom';
                        Ext.getCmp('period_field_report').setValue('custom');
                        Ext.getCmp('tabular_period_field_report').setValue('custom');
                        var params = {jsonData: config};
                        Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/getcp',success,params);

                    }

                });

                var cpdata = chart.getData().cpdata;


                var metric_data = [];
                var detailed_items = [];

                var legend_data = [], c = 0, ef = ['_baseline_up','_baseline_down','_abs_max','_abs_min','_realistic','_optimistic','_pessimistic'];
                var findef = function(ep){ return function(e) { return (ep.indexOf(e) !== -1);};};

                var cp_color = new Colors();
                var m_color = cp_color.getCPColors();

                //Detailed graphics
                for (var i in d.metric) {
                    var graphs = [];
                    var guides = [];

                    var color = m_color[c%cp_color.cpColorsAvailable()];

                    var metric = {
                        unit: d.unit[i],
                        color: '',
                        metric: d.metric[i],
                        max: d.cpdata_max[i],
                        min: d.cpdata_min[i],
                        avg: d.cpdata_avg[i],
                        perc95: d.cpdata_perc95[i],
                        last: d.cpdata_last[i],
                        end_date: null
                    };

                    if (chart.getFutureGuide() && d.cpdata_future_data_break && d.cpdata_future_data_break[i]) {
                        metric.end_date = new Date(d.cpdata_future_data_break[i] * 1000);
                    }

                    if (ef.some(findef(d.metric[i]))) {
                        color = Op.Reports.Utils.shadeBlend(-0.4,m_color[c%cp_color.cpColorsAvailable() - 1]);
                        metric.color = color;
                        metric_data.push(metric);
                        continue;
                    } else {
                        metric.color = color;
                        metric_data.push(metric);
                        c++;
                    }

                    var m = d.metric[i];
                    var unit = d.unit[i];
                    var oguide = {};

                    //future trend guide
                    if (chart.getFutureGuide()) {
                        oguide = {date: false, toDate: false, type: 'trend', fillColor: '#FAFC88', balloonColor: '#FAFC88', balloonText:Ext.locale.translate('Future Trend'), fillAlpha: 0.2, lineAlpha: 0};
                        for (var s in cpdata){
                            var v = cpdata[s];
                            if (v.isTrend === true){
                                if (!oguide.date){
                                    oguide.date = v.date;
                                }
                                oguide.toDate = v.date;
                            }
                        }
                        guides.push(Ext.clone(oguide));
                    }

                    //baseline guides from server
                    if (chart.getBaselineGuide()) {
                        oguide = {date: null, toDate: null, fillColor: null, balloonColor: null, balloonText:null, fillAlpha: 0.2, lineAlpha: 0, inside: true, above: true};
                        if (d.cpdata_guides && d.cpdata_guides[i] && d.cpdata_guides[i].hasOwnProperty('baseline')){
                            for (var j in d.cpdata_guides[i].baseline){
                                var vv = d.cpdata_guides[i].baseline[j];
                                var guidetype = (vv.type == Ext.app.Config.BASELINE_METHOD_TOP) ? '_baseline_up' : '_baseline_down';
                                var baselineTrendMethodLabel = m + guidetype; //up and down;
                                oguide.date = new Date(vv.start * 1000);
                                oguide.toDate = new Date(vv.end * 1000);
                                oguide.fillColor = Ext.clone(color);
                                oguide.balloonColor = oguide.fillColor;
                                oguide.balloonText = m + ' ' +((baselineTrendMethodLabel.indexOf('_baseline_down') != -1) ?
                                                               Ext.locale.translate('Exceeded the Upper limit') :
                                                               Ext.locale.translate('Exceeded the Upper limit'));
                                guides.push(Ext.clone(oguide));
                            }
                        }

                    }

                    var balloon = "<span class='amCharts-balloon'>" + m + ": [[value]] " + unit + '</span>';

                    graphs.push({lineColor: color,valueField: m,lineThickness: 1,title: m, balloonText: balloon});

                    m = d.metric[i]+'_baseline_up';

                    color = Op.Reports.Utils.shadeBlend(-0.4,color);
                    balloon = "<span class='amCharts-balloon'>" + m + ": [[value]] " + unit + '</span>';
                    if (d.metric.indexOf(m) !== -1) {
                        graphs.push({lineColor: color,valueField: m,lineThickness: 1,title: m, balloonText: balloon});
                    }
                    m = d.metric[i]+'_baseline_down';
                    if (d.metric.indexOf(m) !== -1) {
                        graphs.push({lineColor: color,valueField: m,lineThickness: 1,title: m, balloonText: balloon});
                    }
                    m = d.metric[i]+'_abs_max';
                    if (d.metric.indexOf(m) !== -1) {
                        graphs.push({lineColor: color,valueField: m,lineThickness: 1,title: m, balloonText: balloon});
                    }
                    m = d.metric[i]+'_abs_min';
                    if (d.metric.indexOf(m) !== -1) {
                        graphs.push({lineColor: color,valueField: m,lineThickness: 1,title: m, balloonText: balloon});
                    }
                    m = d.metric[i]+'_future';
                    if (d.metric.indexOf(m) !== -1) {
                        graphs.push({lineColor: color,valueField: m,lineThickness: 1,title: m, balloonText: balloon});
                    }

                    var chartConfig = {
                        type: "serial",
                        theme: "light",
                        language: Ext.locale.shortlang,
                        valueAxes: [{
                            axisAlpha: 0,
                            position: "left",
                            unit: unit
                        }],
                        legend: {
                            useGraphSettings: false,
                            autoMargins: true,
                        },
                        chartCursor: {
                            cursorPosition: 'mouse',
                            zoomable: false,
                            valueLineEnabled: true,
                            valueLineBalloonEnabled: true,
                            cursorAlpha: 0,
                            valueLineAlpha: 0,
                            categoryBalloonDateFormat: "MMM DD, YYYY - JJ:NN"
                        },
                        balloon: {
                            borderThickness: 1,
                            shadowAlpha: 0
                        },
                        graphs: Ext.clone(graphs),
                        dataProvider: Ext.clone(cpdata),
                        categoryField: "date",
                        categoryAxis: {
                            parseDates: true,
                            minPeriod: 'fff',
                            dashLength: 1,
                            gridAlpha: 0.15,
                            minorGridEnabled: true,
                            gridPosition: "start",
                            guides: Ext.clone(guides)
                        },
                        amExport: {}
                    };

                    detailed_items.push({x:0,y:0,width:1,height:3,id:i,title:d.metric[i],chart:chartConfig});
                }

                Ext.getStore('metric_store').loadData(metric_data);
                var portal = Ext.getCmp('detailed_tab');
                portal.setDashboardData(detailed_items);

                chart.chart.validateNow();
            } else {
                me.setOverviewNoData(true);
            }
        };
        var params = {jsonData: config};
        Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/getcp',success,params);
    },

    loadTabularContent: function() {
        var tabular_data = [];
        var me = this;
        var config = Ext.app.Config.getOptions();
        config.selectedItens = [];
        Ext.getStore('service_paging').proxy.data.forEach(function(o){
            config.selectedItens.push(o.value);
        });
        config.objectType = Ext.app.Config.SERVICE;
        config.summarizePoints = 10;

        var params = {jsonData: config};

        Ext.getCmp('graphic_report_settings1').getForm().reset();
        Ext.getCmp('tabular_period_container').getForm().reset();
        var success = function(o) {
            if (o && o.length) {
                var index = 1, max_limit, usage, variation, p, d, ii, m;

                d = o[0];
                config.host_name = "";
                config.service_description = "";
                config.current_period = Ext.Date.format(new Date(d.tsBegin*1000), Ext.app.Config.LONG_DATE_FORMAT)+' '+Ext.locale.translate('to')+' '+Ext.Date.format(new Date(d.tsEnd*1000), Ext.app.Config.LONG_DATE_FORMAT);
                config.current_duration = Op.Reports.Utils.Date.duration(d.tsEnd - d.tsBegin);
                Ext.getCmp('graphic_report_settings1').getForm().setValues(config);
                Ext.getCmp('tabular_period_container').getForm().setValues(config);

                for (var i in o) {
                    d = o[i];
                    var cpdata = {};
                    if (d.cpdata) {
                        for (m in d.cpdata) {
                            for (ii in d.metric){
                                if (!cpdata[d.metric[ii]]) {
                                    cpdata[d.metric[ii]] = [];
                                }
                                cpdata[d.metric[ii]].push(d.cpdata[m][d.metric[ii]]);
                            }
                        }
                    }

                    for (ii in d.metric){
                        if (config.percentGraphs == "1") {
                            max_limit = 100;
                        } else {
                            max_limit = (d.hasOwnProperty('limits') && d.limits.max[ii] > 0) ? d.limits.max[ii] : ((d.cpdata_max[ii] > 0) ?  d.cpdata_max[ii] :  null);
                        }

                        p = {host:d.host_name,service:d.service_description,metric:d.metric[ii],max:d.cpdata_max[ii],min:d.cpdata_min[ii],avg:d.cpdata_avg[ii],color:""};

                        p.limitMax = (d.limits.max[ii] === null || d.limits.max[ii] === undefined) ? d.cpdata_max[ii] : d.limits.max[ii];

                        p.limitMin = (d.limits.min[ii] === null || d.limits.min[ii] === undefined) ? d.cpdata_min[ii] : d.limits.min[ii];

                        p.index = index++;

                        p.unit = d.unit[ii];

                        p.variation = (max_limit >0) ? Number(max_limit - p.avg).toFixed(2) : 0;

                        p.usage = Number( (max_limit > 0) ? Number((100 / max_limit) * p.avg).toFixed(2) : null);

                        p.cpdata = [];

                        var cpsum = 0;
                        var cpns = Math.ceil(cpdata[d.metric[ii]].length / 10);

                        //data post sumarization
                        for (m in cpdata[d.metric[ii]]) {
                            cpsum += cpdata[d.metric[ii]][m];
                            if (m%cpns===0) {
                                p.cpdata.push({label: p.cpdata.length,value:cpsum});
                                cpsum = 0 ;
                            }
                        }

                        if (config.showThresholdCp === "1") {
                            if (d.cpdata_critical[ii] !== "" && d.cpdata_warn[ii] !== "") {
                                if (d.cpdata_warn[ii] > d.cpdata_critical[ii]) {
                                    if (p.avg <= d.cpdata_critical[ii])
                                        p.color = Ext.app.Config.COLOR_CRITICAL;
                                    else if (p.avg <= d.cpdata_warn[ii])
                                        p.color = Ext.app.Config.COLOR_WARNING;
                                    else
                                        p.color = Ext.app.Config.COLOR_OK;
                                } else {
                                    if (p.avg >= d.cpdata_critical[ii])
                                        p.color = Ext.app.Config.COLOR_CRITICAL;
                                    else if (p.avg >= d.cpdata_warn[ii])
                                        p.color = Ext.app.Config.COLOR_WARNING;
                                    else
                                        p.color = Ext.app.Config.COLOR_OK;
                                }
                            } else {
                                p.color = Ext.app.Config.COLOR_UNKNOWN;
                            }
                        }

                        tabular_data.push(p);
                    }
                }
                Ext.getStore('tabular_store').loadData(tabular_data);
            }

            Ext.getBody().unmask();
        };

        Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/getcp',success,params);



    },

    loadCustomContent: function() {
        var config = Ext.app.Config.getOptions();
        delete config.reportName;
        delete config.username;
        config.format = 'pdf';
        config.sendByEmail = false;
        params = {jsonData: config};

        var success = function(o) {

            if (o && o.status == 'ok' && o.cacheurl) {
                var custom_content = Ext.getCmp('custom_content');
                custom_content.pageScale = 1.5;
                custom_content.setSrc(o.cacheurl);

                //Ext.get('pdfIframe').dom.src = o.output;
            }

            Ext.getBody().unmask();
        };
        Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/opexporter/action/gencustomreport',success,params);
    },

    getTools: function() {
        return [{
            xtype: 'tool',
            type: 'gear',
            handler: function(e, target, header, tool){
                var portlet = header.ownerCt;
                portlet.setLoading(true);
                Ext.defer(function() {
                    portlet.setLoading(false);
                }, 2000);
            }
        }];
    },

    onTabularContentColumnRender: function(val, cell) {
        val = Ext.util.Format.number(val,'0,000.000');
        if (cell.record && cell.record.raw.color !== "") {
            return '<span style="color:' + cell.record.raw.color + '">' + val + cell.record.raw.unit +'</span>';
        } else if (cell.record) {
            return val+cell.record.raw.unit;
        } else {
            return val;
        }

    },

    onTabularContentColumnRenderProgressbar: function(val, cell) {
        var id = Ext.id();
        var m = Ext.clone(cell.record.raw);
        Ext.defer(function () {
            var bar = Ext.widget('progressbar', {
                renderTo: id,
                value: val/100,
                text:Ext.util.Format.number(val,'0,000.000')+'%',
                width: 100,
            });
            var color = m.color || Ext.app.Config.COLOR_PROGRESSBAR;
            bar.getEl().child(".x-progress-bar", true).style.backgroundColor = color;
            bar.getEl().child(".x-progress-bar", true).style.borderRightColor = color;
            bar.getEl().child(".x-progress-bar", true).style.backgroundImage = "url('')";

        }, 50);
        return Ext.String.format('<div id="{0}"></div>', id);
    },

    onTabularContentColumnRenderSparkline: function(val, cell) {
        var id = Ext.id();
        var m = Ext.clone(cell.record.raw);
        Ext.defer(function () {
            // line chart, with a bullet at the end
            var chart = new AmCharts.AmSerialChart(AmCharts.themes.none);
            chart.dataProvider = m.cpdata;
            chart.categoryField = "label";
            chart.autoMargins = false;
            chart.marginLeft = 0;
            chart.marginRight = 5;
            chart.marginTop = 0;
            chart.marginBottom = 0;
            chart.height = 18;

            var graph = new AmCharts.AmGraph();
            graph.valueField = "value";

            graph.lineColor = m.color || Ext.app.Config.COLOR_SPARKLINE;
            graph.lineThickness = 1;

            chart.addGraph(graph);

            var valueAxis = new AmCharts.ValueAxis();
            valueAxis.gridAlpha = 0;
            valueAxis.axisAlpha = 0;
            chart.addValueAxis(valueAxis);

            var categoryAxis = chart.categoryAxis;
            categoryAxis.gridAlpha = 0;
            categoryAxis.axisAlpha = 0;
            categoryAxis.startOnAxis = true;
            chart.write(id);
        }, 50);

        return Ext.String.format('<div id="{0}"></div>', id);
    },

    reloadContent: function() {
        var overview_content = Ext.getCmp('overview_content');
        var tabular_content = Ext.getCmp('tabular_content');
        if (overview_content.isVisible()) {
            Ext.getCmp('overview_paging').doRefresh();
        } else if (tabular_content.isVisible()) {
            this.loadTabularContent();
        }
    },

    loadContent: function(updateOptions) {

        var me = this;
        var config = Ext.app.Config.getOptions((updateOptions === false ) ? false : true);
        if (config.reportType === Ext.app.Config.CUSTOM) {
            this.viewContent();
        } else {
            params = {jsonData:{selectedItens:config.selectedItens,objectType:config.objectType}};

            Ext.getBody().mask("Please wait...");

            var success = function(response) {

                if (!response || !response.length) {
                    me.viewContent();
                    me.setOverviewNoData();
                    return false;
                }

                var selectedItems = Ext.getStore('selectedItems');
                selectedItems.removeAll();
                selectedItems.add(response);

                var service_paging = Ext.getStore('service_paging');

                //force proxy recreation to use local data in paging component
                service_paging.setProxy({data: response, type: 'memory',enablePaging: true,reader: {type: 'array'}});

                //force first page on proxy reload
                service_paging.currentPage = 1;

                me.viewContent();

                if (config.reportType !== Ext.app.Config.CPTABULAR) {
                    service_paging.load();
                }

            };
            Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/getservicesbyobjecttype',success,params);
        }
    },

    viewContent: function(visible) {
        visible = (visible === undefined || visible === true) ? true : false;
        var config = Ext.app.Config.getOptions();

        Ext.getCmp('export_bar').setVisible(true);
        Ext.getCmp("toolbarcard").layout.setActiveItem("graphic_tools");

        if (config.reportType === Ext.app.Config.CUSTOM) {
            Ext.getCmp('export_xls_button').setVisible(true);
            Ext.getCmp('export_png_button').setVisible(false);
            Ext.getCmp("card_container").layout.setActiveItem("custom_card");
        } else {
            Ext.getCmp("card_container").layout.setActiveItem("graphic_card");
            Ext.getCmp("overview_container").layout.setActiveItem("overview_content");
            if (config.reportType === Ext.app.Config.CPTABULAR) {
                Ext.getCmp("overview_container").layout.setActiveItem("tabular_content");
                Ext.getCmp('export_png_button').setVisible(false);
            } else {
                Ext.getCmp("overview_container").layout.setActiveItem("overview_content");
                Ext.getCmp('export_png_button').setVisible(true);
            }
            Ext.getCmp('export_xls_button').setVisible(false);
            Ext.getCmp('period_field_report').setValue(config.reportPeriod);
            Ext.getCmp('tabular_period_field_report').setValue(config.reportPeriod);
            Ext.getCmp('timecut_report').setValue(config.timeCutId);
        }
    },

    setOverviewNoData: function(visible) {
        visible = (visible === undefined || visible) ? true : false;
        Ext.getCmp('graphic_container').setVisible(!visible);
        Ext.getCmp('legend_grid').setVisible(!visible);
        Ext.getCmp('overview_nodata_content').setVisible(visible);

        Ext.getBody().unmask();
    },

    clearOldChart: function() {
        var report = Ext.getCmp('graphic_container').chart;

        if (report && report.chart) {
            report.chart.clear();
            report.chart.cleanChart();
            report.chart = null;
        }
    },

    loadFromParameter: function(hasToPlot) {
        var config = Ext.app.Config.getOptions();
        var params = {jsonData:{selectedItens:config.selectedItens,objectType:config.objectType}};
        var mainController = Reports.app.getController("MainController");

        mainController.onResetReady = function() {
            var reportform = Ext.getCmp("configuration_container");
            var cfg = params.jsonData;
            var selectedStore = Ext.getStore("selected_objects");
            var selected = params.jsonData.selectedItens.map(function(el) {
                var fresh = Ext.apply({}, { value: el.id, name: el.service_description ? el.service_description : el.hostname }, el);
                delete fresh.id;
                delete fresh.service_description;
                if (!fresh.name) delete fresh.name;
                return fresh;
            }).filter(function(el) {
                return !!el.name && el.name.length > 0;
            });
            cfg.selectedItens = params.jsonData.selectedItens.map(function(el) { return el.id; });
            var config = Ext.app.Config.setOptions(cfg);
            reportform.getForm().setValues(config);
            Ext.app.Config.setAdvOptions(config);
            selectedStore.add(selected);
            Ext.getCmp("output_wrapper").show();

            mainController.handlerMetricsAvailableStore();

            if (hasToPlot) {
                setTimeout(function() {
                    Ext.ComponentQuery.query('#generate_btn').forEach(function(el) {
                        el.fireEvent('click');
                    });
                });
            }
        };
    },

    init: function(application) {
        this.control({
            "#overview_paging": {
                change: this.onOverviewPagingChange
            },
            "#legend_panel_button_check": {
                click: this.onLegendPanelButtonToggleClick
            },
            "#legend_panel_button_thresholds": {
                click: this.onLegendPanelButtonThresholdsClick
            },
            "#legend_panel_button_autoscale": {
                click: this.onLegendPanelButtonAutoscaleClick
            },
            "#period_field_report,#timecut_report, #tabular_period_field_report": {
                collapse: this.onPeriodReportCollapse
            },
            "#report_period_submit": {
                click: this.onReportPeriodWindowButtonClick
            },
            "#tabular_content": {
                show: this.onTabularContentShow
            },
            "#overview_host_name,#overview_service_description,#overview_current_duration,#overview_current_period": {
                change: this.onOverviewHeaderDescriptionChange
            },
            "#custom_card": {
                show: this.onCustomCardShow
            },
            "#overview_content": {
                show: this.onOverviewContentShow
            },
            "#overview_btn,#detailed_btn": {
                toggle: this.onOverviewBtnToggle
            }
        });
    }

});
