/*
 * File: app/controller/MainController.js
 *
 * This file was generated by Sencha Architect version 4.2.4.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Reports.controller.MainController', {
    extend: 'Ext.app.Controller',

    metricColumnHighlight: false,
    id: 'mainEmbed',

    refs: [
        {
            ref: 'mainview',
            selector: 'main_view'
        }
    ],

    onReportTypeChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp('aggregate_by_metric').show();
        switch (newValue) {
            case Ext.app.Config.CUSTOM:
                Ext.getCmp("advanced_95pc").setDisabled(true).setChecked(false);
                Ext.getCmp("advanced_trendlines").setDisabled(true).setChecked(false);
                Ext.getCmp("advanced_futuretrend").setDisabled(true).setChecked(false);
                Ext.getCmp("advanced_absoluteminmax").setDisabled(false);
                Ext.getCmp("custom_report_container").show();
                Ext.getCmp("groupedby_field").hide();
                Ext.getCmp("report_type_field").setMargin("0 0 5");
                Ext.getCmp('toggle_detail_btn').show();
                break;
            case Ext.app.Config.CPGROUPBY:
                Ext.getCmp("advanced_95pc").setDisabled(true).setChecked(false);
                Ext.getCmp("advanced_trendlines").setDisabled(true).setChecked(false);
                Ext.getCmp("advanced_futuretrend").setDisabled(true).setChecked(false);
                Ext.getCmp("advanced_absoluteminmax").setDisabled(true).setChecked(false);
                Ext.getCmp("custom_report_container").hide();
                Ext.getCmp("groupedby_field").show();
                Ext.getCmp("report_type_field").setMargin("0 0 5");
                Ext.getCmp('toggle_detail_btn').show();
                break;
            case Ext.app.Config.CPDEFAULT:
                Ext.getCmp("advanced_95pc").setDisabled(false);
                Ext.getCmp("advanced_trendlines").setDisabled(false);
                Ext.getCmp("advanced_futuretrend").setDisabled(false);
                Ext.getCmp("advanced_absoluteminmax").setDisabled(false);
                Ext.getCmp("custom_report_container").hide();
                Ext.getCmp("groupedby_field").hide();
                Ext.getCmp("report_type_field").setMargin("0 0 10");
                Ext.getCmp('toggle_detail_btn').show();
                break;
            case Ext.app.Config.CPTABULAR:
                Ext.getCmp("advanced_95pc").setDisabled(true).setChecked(false);
                Ext.getCmp("advanced_trendlines").setDisabled(true).setChecked(false);
                Ext.getCmp("advanced_futuretrend").setDisabled(true).setChecked(false);
                Ext.getCmp("advanced_absoluteminmax").setDisabled(true).setChecked(false);
                Ext.getCmp("custom_report_container").hide();
                Ext.getCmp("groupedby_field").hide();
                Ext.getCmp('aggregate_by_metric').setValue(false);
                Ext.getCmp('aggregate_by_metric').hide();
                Ext.getCmp('toggle_detail_btn').hide();
                break;
        }
    },

    onPeriodComboboxChange: function(field, newValue, oldValue, eOpts) {
        if (newValue === "custom") {
            Ext.getCmp("period_from").show();
            Ext.getCmp("period_to").show();
            Ext.getCmp("period_last").hide();
            Ext.getCmp("period_field").setMargin("0 0 5");
        } else if (newValue === "last") {
            Ext.getCmp("period_last").show();
            Ext.getCmp("period_from").hide();
            Ext.getCmp("period_to").hide();
            Ext.getCmp("period_field").setMargin("0 0 5");
        } else {
            Ext.getCmp("period_last").hide();
            Ext.getCmp("period_from").hide();
            Ext.getCmp("period_to").hide();
            Ext.getCmp("period_field").setMargin("0 0 10");
        }
    },

    onDatefieldBeforeRender: function(component, eOpts) {
        component.setValue(new Date());
    },

    onPeriodFromDateChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp("period_to_date").setMinValue(newValue);
    },

    onPeriodChange: function(field, newValue, oldValue, eOpts) {
        var period_from_date_val = Ext.getCmp("period_from_date").getValue();
        var period_to_date_val = Ext.getCmp("period_to_date").getValue();
        if (period_to_date_val !== null && period_from_date_val !== null && period_to_date_val.toString() == period_from_date_val) {
            var period_from_time_val = Ext.getCmp("period_from_time").getValue();
            var period_to_time = Ext.getCmp("period_to_time");
            period_to_time.setMinValue(period_from_time_val);
        } else {
            Ext.getCmp("period_to_time").setMinValue("");
        }
    },

    onPeriodToDateAfterRender: function(component, eOpts) {
        component.setMinValue(Ext.getCmp("period_from_date").getValue());
    },

    onPeriodLastTypeChange: function(field, newValue, oldValue, eOpts) {
        var period_last_number = Ext.getCmp("period_last_number");
        var period_last_limit = field.getStore().getAt(0).data.limit;
        period_last_number.setMaxValue(period_last_limit);
        if (period_last_number.getValue() > period_last_limit) {
            period_last_number.setValue(period_last_limit);
        }
    },

    onObjectTypeChange: function(field, newValue, oldValue, eOpts) {
        var objtype = Ext.getCmp("object_type").getValue();
        if (objtype == Ext.app.Config.SERVICE) {
            Ext.getCmp("host_selection_wrapper").show();
        } else {
            Ext.getCmp("host_selection_wrapper").hide();
        }

        var store_available = Ext.getStore('available_objects');
        store_available.removeAll();

        var store_selected = Ext.getStore('selected_objects');
        store_selected.removeAll();

        var host_selection_objects = Ext.getStore('host_selection_objects');
        host_selection_objects.removeAll();

        Ext.getStore('metricsAvailable').removeAll();

        switch(objtype) {
            case Ext.app.Config.HOST :
                Op.Reports.Utils.getElements('gethostsbyservices',function(o) {
                    var available_objects = Ext.getStore('available_objects');
                    available_objects.loadData(o);
                });
                Ext.getCmp('metric_service_column').show();
                Ext.getCmp("hostname_column").hide();
                Ext.getCmp("metricname_column").hide();
                break;
            case Ext.app.Config.SERVICE :
                Op.Reports.Utils.getElements('gethostsbyservices',function(o) {
                    var host_selection_objects = Ext.getStore('host_selection_objects');
                    host_selection_objects.loadData(o);
                    var first = o[0].value;
                    var combo = Ext.getCmp('host_selection');
                    combo.setValue(first);
                    combo.fireEvent('change', combo, first,first);
                });
                Ext.getCmp("hostname_column").show();
                Ext.getCmp("metricname_column").hide();
                break;
            case Ext.app.Config.HOSTGROUP :
                Op.Reports.Utils.getElements('gethostgroupnames',function(o) {
                    var available_objects = Ext.getStore('available_objects');
                    available_objects.loadData(o);
                });
                Ext.getCmp('metric_service_column').show();
                Ext.getCmp("hostname_column").hide();
                Ext.getCmp("metricname_column").hide();
                break;
            case Ext.app.Config.SERVICEGROUP :
                Op.Reports.Utils.getElements('getservicegroupnames',function(o) {
                    var available_objects = Ext.getStore('available_objects');
                    available_objects.loadData(o);
                });
                Ext.getCmp('metric_service_column').show();
                Ext.getCmp("hostname_column").hide();
                Ext.getCmp("metricname_column").hide();
                break;
        }

        if (newValue !== "") {
            Ext.getCmp("right_card_container").layout.setActiveItem("content_card");
        } else {
            Ext.getCmp("right_card_container").layout.setActiveItem("pointer_card");
        }
    },

    onAvailableElementsViewCellDblClick: function(tableview, td, cellIndex, record, tr, rowIndex, e, eOpts) {
        var store_available = Ext.getStore('available_objects');
        var store_selected = Ext.getStore('selected_objects');

        if ( ! store_selected.getById(record.getId())) {
            this.concatHostNameAndServiceDescription(record);
            store_selected.add(record);
        }

        store_available.remove(record);

        var selected_elements = Ext.getCmp("selected_elements");
        var selected_elements_num = store_selected.data.items.length;
        if (selected_elements_num !== 0) {
            Ext.getCmp("objects_wrapper").setTitle(Ext.String.format('<span class="header-num">2</span> {0} '+Ext.locale.translate('Elements Selected for the Report'),selected_elements_num));
            Ext.getCmp("output_wrapper").show();
        } else {
            Ext.getCmp("objects_wrapper").setTitle('<span class="header-num">2</span> '+Ext.locale.translate('Select the Report Objects'));
            Ext.getCmp("output_wrapper").hide();
        }

        this.handlerMetricsAvailableStore();
    },

    onHostSelectionChange: function(field, newValue, oldValue, eOpts) {
        var host_id = Ext.getCmp('host_selection').getValue();
        Op.Reports.Utils.getElements('getservices',function(oo) {
            var available_objects = Ext.getStore('available_objects');
            available_objects.loadData(oo);
        },{host_id: host_id, formTo: Ext.app.Config.CP});
    },

    onSelectedElementsViewCellDblClick: function(tableview, td, cellIndex, record, tr, rowIndex, e, eOpts) {
        var store_available = Ext.getStore('available_objects');
        var store_selected = Ext.getStore('selected_objects');

        this.concatHostNameAndServiceDescription(record);
        store_available.add(record);
        store_selected.remove(record);
        store_available.sort('name','ASC');


        var selected_elements = Ext.getCmp("selected_elements");
        var selected_elements_num = store_selected.data.items.length;
        if (selected_elements_num !== 0) {
            Ext.getCmp("objects_wrapper").setTitle(Ext.String.format('<span class="header-num">2</span> {0} '+Ext.locale.translate('Elements Selected for the Report'),selected_elements_num));
            Ext.getCmp("output_wrapper").show();
        } else {
            Ext.getCmp("objects_wrapper").setTitle('<span class="header-num">2</span> '+Ext.locale.translate('Select the Report Objects'));
        }

        this.handlerMetricsAvailableStore();
    },

    onEmailContainerSelect: function(rowmodel, record, index, eOpts) {
        var email_container = Ext.getCmp("email_container");
        var email_num = email_container.getSelectionModel().getSelection().length;
        if (email_num !== 0) {
            email_container.setTitle(Ext.String.format(Ext.locale.translate('Send by e-mail for {0} contact(s)'),email_num));
        } else {
            email_container.setTitle(Ext.locale.translate('Send by e-mail for'));
        }
    },

    onEmailContainerDeselect: function(rowmodel, record, index, eOpts) {
        var email_container = Ext.getCmp("email_container");
        var email_num = email_container.getSelectionModel().getSelection().length;
        if (email_num !== 0) {
            email_container.setTitle(Ext.String.format(Ext.locale.translate('Send by e-mail for {0} contact(s)'),email_num));
        } else {
            email_container.setTitle(Ext.locale.translate('Send by e-mail for'));
        }
    },

    onGenerateBtnClick: function(button, e, eOpts) {
        this.getController('DefaultController').loadContent();
    },

    onSendAllBtnClick: function(button, e, eOpts) {
        var store_available = Ext.getStore('available_objects');
        var store_selected = Ext.getStore('selected_objects');

        var me = this;
        Ext.each(store_available.data.items, function (record) {
            if ( ! store_selected.getById(record.getId())) {
                me.concatHostNameAndServiceDescription(record);
                store_selected.add(record);
            }
        });

        store_available.remove(store_available.data.items);


        var selected_elements = Ext.getCmp("selected_elements");
        var selected_elements_num = store_selected.data.items.length;
        if (selected_elements_num !== 0) {
            Ext.getCmp("objects_wrapper").setTitle(Ext.String.format('<span class="header-num">2</span> {0} '+Ext.locale.translate('Elements Selected for the Report'),selected_elements_num));
            Ext.getCmp("output_wrapper").show();
        } else {
            Ext.getCmp("objects_wrapper").setTitle('<span class="header-num">2</span> '+Ext.locale.translate('Select the Report Objects'));
            Ext.getCmp("output_wrapper").hide();
        }

        this.handlerMetricsAvailableStore();
    },

    onSendOneBtnClick: function(button, e, eOpts) {
        var store_available = Ext.getStore('available_objects');
        var store_selected = Ext.getStore('selected_objects');
        var objects_to_add = Ext.getCmp("available_elements").getSelectionModel().getSelection();
        for (var obj in objects_to_add) {
            if ( ! store_selected.getById(objects_to_add[obj].getId())) {
                this.concatHostNameAndServiceDescription(objects_to_add[obj]);
                store_selected.add(objects_to_add[obj]);
            }

            store_available.remove(objects_to_add[obj]);
        }

        var selected_elements = Ext.getCmp("selected_elements");
        var selected_elements_num = store_selected.data.items.length;
        if (selected_elements_num !== 0) {
            Ext.getCmp("objects_wrapper").setTitle(Ext.String.format('<span class="header-num">2</span> {0} '+Ext.locale.translate('Elements Selected for the Report'),selected_elements_num));
            Ext.getCmp("output_wrapper").show();
        } else {
            Ext.getCmp("objects_wrapper").setTitle('<span class="header-num">2</span> '+Ext.locale.translate('Select the Report Objects'));
            Ext.getCmp("output_wrapper").hide();
        }

        this.handlerMetricsAvailableStore();
    },

    onRemoveOneBtnClick: function(button, e, eOpts) {
        var store_available = Ext.getStore('available_objects');
        var store_selected = Ext.getStore('selected_objects');
        var objects_to_remove = Ext.getCmp("selected_elements").getSelectionModel().getSelection();
        for (var obj in objects_to_remove) {
            store_available.add(objects_to_remove[obj]);
            store_selected.remove(objects_to_remove[obj]);
        }
        store_available.sort('name','ASC');


        var selected_elements = Ext.getCmp("selected_elements");
        var selected_elements_num = store_selected.data.items.length;
        if (selected_elements_num !== 0) {
            Ext.getCmp("objects_wrapper").setTitle(Ext.String.format('<span class="header-num">2</span> {0} '+Ext.locale.translate('Elements Selected for the Report'),selected_elements_num));
            Ext.getCmp("output_wrapper").show();
        } else {
            Ext.getCmp("objects_wrapper").setTitle('<span class="header-num">2</span> '+Ext.locale.translate('Select the Report Objects'));
        }

        this.handlerMetricsAvailableStore();
    },

    onRemoveAllBtnClick: function(button, e, eOpts) {
        var store_available = Ext.getStore('available_objects');
        var store_selected = Ext.getStore('selected_objects');
        store_available.add(store_selected.data.items);
        store_selected.remove(store_selected.data.items);
        store_available.sort('name','ASC');

        var selected_elements = Ext.getCmp("selected_elements");
        var selected_elements_num = store_selected.data.items.length;
        if (selected_elements_num !== 0) {
            Ext.getCmp("objects_wrapper").setTitle(Ext.String.format('<span class="header-num">2</span> {0} '+Ext.locale.translate('Elements Selected for the Report'),selected_elements_num));
            Ext.getCmp("output_wrapper").show();
        } else {
            Ext.getCmp("objects_wrapper").setTitle('<span class="header-num">2</span> '+Ext.locale.translate('Select the Report Objects'));
        }

        this.handlerMetricsAvailableStore();
    },

    savedReportsComboboxChange: function(field, newValue, oldValue, eOpts) {
        if (newValue === null) {
            return false;
        }
        this.loadReport(newValue);
    },

    onSaveReportClick: function(button, e, eOpts) {
        this.saveReport();
    },

    onSaveReportAsClick: function(item, e, eOpts) {
        this.saveReport(true);
    },

    onCreateReportClick: function(button, e, eOpts) {
        this.resetReportScreen();
    },

    onDeleteReportClick: function(button, e, eOpts) {
        var me= this;
        var config = Ext.app.Config.getOptions();
        if (!config.id) {
            return;
        }
        var success = function(o){
            Ext.MessageBox.alert(Ext.locale.translate('Status'), Ext.locale.translate('Removed successfully.'));
            me.resetReportScreen();
        };
        var action = function(btn) {
            if (btn == 'yes') {
                var params = {id: config.id};
                Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/removereport',success,params, false);
            }
        };
        Ext.MessageBox.confirm(Ext.locale.translate('Confirm'), Ext.locale.translate('Remove current report ?'), action);

    },

    onSaveReportFormOkClick: function(button, e, eOpts) {
        var me = this;
        var config = Ext.app.Config.getOptions(true);
        var success = function(o){
            if (o.output) {
                Ext.MessageBox.alert(Ext.locale.translate('Status'), Ext.locale.translate('Changes saved successfully.'));
                if (!config.id && config.reportName) {
                    var savedreports = Ext.getStore('saved_reports');
                    savedreports.add({name: config.reportName,value: o.output});
                    Ext.getCmp("saved_reports_combo").setValue(o.output);
                }
                me.loadReport(o.output);
            }
        };


        var data = button.up('form').getValues();

        if (data.report_name == '') {
            button.up('form').down('textfield').setActiveError(true);
            return false;
        }

        config.reportName = data.report_name;
        config.allMayView = data.allow_all;
        config.id = "";


        if (Ext.getCmp('aggregate_by_metric').getValue() && config.selectedItensDescription.length > 0) {
            config.selectedItens = [];

            config.selectedItensDescription.forEach(function (item) {
                config.selectedItens = config.selectedItens.concat(item.value.split("!"));
            });

            var cmb = Ext.getCmp('object_type');
            if (cmb.getValue() !== Ext.app.Config.HOST) {
                config.objectType = cmb.getValue();
                Ext.getStore('selected_objects').each(function(selected_item) {
                    config.selectedItens.push(selected_item.get('value'));
                });
            } else {
                config.objectType = Ext.app.Config.SERVICE;
            }
        }

        delete config.selectedItensDescription;

        if (config.reportType !== Ext.app.Config.CUSTOM){
            delete config.customReport;
        }

        var params = {json: config};
        Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/savereport',success,params);

        button.up('window').destroy();
    },

    onCustomReportUploadChange: function(filebutton) {
        var field = Ext.getCmp('custom_report_upload');
        var file = field.getEl().down('input[type=file]').dom.files[0];
        var reader = new FileReader();
        reader.readAsBinaryString(file);
        reader.onload = function (event) {
            field.reset();
            var filename = file.name.split('.')[0];
            var filedata = Op.Reports.Utils.Base64.encode(event.target.result);
            var params = {jsonData: {name: filename, dataset: Ext.app.Config.CP, data: filedata, description:'CustomReport'}};
            Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/opreports/action/uploadcustomreport',function(o){
                if (o.output === 0) {
                    Ext.MessageBox.alert(Ext.locale.translate('Status'), Ext.locale.translate('Your report has been uploaded.'));
                    var custom_reports = Ext.getStore('custom_reports');
                    custom_reports.add({name: filename,value: o.id});
                    Ext.getCmp("custom_report_field").setValue(o.id);
                } else {
                    Ext.MessageBox.alert(Ext.locale.translate('Error'), Ext.locale.translate('Problem uploading your report'));
                }
            },params,true);
        };
    },

    onCustomReportUploadAfterRender: function(component, eOpts) {
        component.fileInputEl.set({
            accept:'.zip,.Zip'
        });
    },

    onCustomReportDownloadButtonClick: function(button, e, eOpts) {
        var custom_report_id = Ext.getCmp('custom_report_field').getValue();
        if (custom_report_id) {
            window.open("/opmon/seagull/www/index.php/opreports/action/getcustomreports/id/"+custom_report_id+"/download/1", "_blank");
        }
    },

    onCustomReportRemoveButtonClick: function(button, e, eOpts) {
        var custom_report_id = Ext.getCmp('custom_report_field').getValue();

        var success = function(o) {
            if (o.output === 0) {
                Ext.MessageBox.alert(Ext.locale.translate('Status'), Ext.locale.translate('Report removed successfully.'));
                var custom_reports = Ext.getStore('custom_reports');
                var c_index = custom_reports.find('value',custom_report_id);
                custom_reports.removeAt(c_index);
                Ext.getCmp('custom_report_field').clearValue();
            }
        };

        var action = function(btn) {
            if (btn == 'yes'){
                var params = {id: custom_report_id};
                Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/opreports/action/removecustomreport',success,params);
            }
        };

        if (custom_report_id) {
            Ext.MessageBox.confirm(Ext.locale.translate('Confirm'), Ext.locale.translate('Remove report ?'), action);
        }
    },

    onAdvanced_trendlinesCheckChange: function(menucheckitem, checked, eOpts) {
        if (checked === true) {
            Ext.getCmp("advanced_graphicsinpc").setDisabled(true);
            Ext.getCmp("advanced_futuretrend").setDisabled(true);
            Ext.getCmp("advanced_absoluteminmax").setDisabled(true);
            Ext.getCmp("report_type_field").setDisabled(true);
            Ext.getCmp("advanced_trendlines_showalarms").show();
        } else {
            Ext.getCmp("advanced_graphicsinpc").setDisabled(false);
            Ext.getCmp("advanced_futuretrend").setDisabled(false);
            Ext.getCmp("advanced_absoluteminmax").setDisabled(false);
            Ext.getCmp("report_type_field").setDisabled(false);
            Ext.getCmp("advanced_trendlines_showalarms").hide();
        }

        var advanced_options = Ext.getCmp('advanced_options').query('menucheckitem');
        var counter_local = 0;
        var first_el = 0;
        Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Output')+': ');
        for (var i=0; i < advanced_options.length; i++) {
            if (advanced_options[i].checked === true && first_el === 0) {
                first_el++;
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + advanced_options[i].text);
            } else if (advanced_options[i].checked === true) {
                first_el++;
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + ' - ' + advanced_options[i].text);
            } else {
                counter_local++;
            }
        }

        if (counter_local === advanced_options.length) {
            Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Define Output'));
        }

        if (checked) {
            Ext.getCmp('aggregate_by_metric').setValue(false);
        }

    },

    onAdvanced_futuretrendCheckChange: function(menucheckitem, checked, eOpts) {
        if (checked === true) {
            Ext.getCmp("advanced_trendlines").setDisabled(true);
            Ext.getCmp("advanced_absoluteminmax").setDisabled(true);
            Ext.getCmp("report_type_field").setDisabled(true);
            Ext.getCmp("advanced_futuretrend_months").show();
        } else {
            Ext.getCmp("advanced_trendlines").setDisabled(false);
            Ext.getCmp("advanced_absoluteminmax").setDisabled(false);
            Ext.getCmp("report_type_field").setDisabled(false);
            Ext.getCmp("advanced_futuretrend_months").hide();
        }

        var advanced_options = Ext.getCmp('advanced_options').query('menucheckitem');
        var counter_local = 0;
        var first_el = 0;
        Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Output')+': ');
        for (var i=0; i < advanced_options.length; i++) {
            if (advanced_options[i].checked === true && first_el === 0) {
                first_el++;
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + advanced_options[i].text);
            } else if (advanced_options[i].checked === true) {
                first_el++;
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + ' - ' + advanced_options[i].text);
            } else {
                counter_local++;
            }
        }
        if (counter_local === advanced_options.length) {
            Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Define Output'));
        }

        if (checked) {
            Ext.getCmp('aggregate_by_metric').setValue(false);
        }
    },

    onAdvanced_absoluteminmaxCheckChange: function(menucheckitem, checked, eOpts) {
        if (checked === true) {
            Ext.getCmp("advanced_futuretrend").setDisabled(true);
            Ext.getCmp("advanced_trendlines").setDisabled(true);
            Ext.getCmp("report_type_field").setDisabled(true);
        } else {
            Ext.getCmp("advanced_futuretrend").setDisabled(false);
            Ext.getCmp("advanced_trendlines").setDisabled(false);
            Ext.getCmp("report_type_field").setDisabled(false);
        }

        var advanced_options = Ext.getCmp('advanced_options').query('menucheckitem');
        var counter_local = 0;
        var first_el = 0;
        Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Output')+': ');
        for (var i=0; i < advanced_options.length; i++) {
            if (advanced_options[i].checked === true && first_el === 0) {
                first_el++;
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + advanced_options[i].text);
            } else if (advanced_options[i].checked === true) {
                first_el++;
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + ' - ' + advanced_options[i].text);
            } else {
                counter_local++;
            }
        }
        if (counter_local === advanced_options.length) {
            Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Define Output'));
        }

    },

    onCheckboxfieldChange: function(field, newValue, oldValue, eOpts) {
        if(newValue === true) {
            Ext.getCmp("email_container").show();
        } else {
            Ext.getCmp("email_container").hide();
        }
    },

    onAggregate_by_metricChange: function(field, newValue, oldValue, eOpts) {
        if (newValue === true) {
            Ext.getCmp("metrics_available").show();
            Ext.getCmp('generate_btn').setDisabled(true);
            Ext.getCmp("select_metric_wrapper").layout.setActiveItem("metric_aggregated_label");
            Ext.getCmp('overview_paging').setVisible(false);
            Ext.getCmp('metrics_available').getView().refresh();
            Ext.getCmp('advanced_futuretrend').setChecked(false);
            Ext.getCmp("legend_grid_column_host").setVisible(true);
            Ext.getCmp("legend_grid_column_service").setVisible(true);
            Ext.getCmp("legend_grid_column_metric").minWidth = 94;
        } else {
            Ext.getCmp("metrics_available").hide();
            Ext.getCmp("select_metric_wrapper").layout.setActiveItem("cmb_selected_reports");
            Ext.getCmp('metrics_available').getSelectionModel().deselectAll();
            Ext.getCmp('overview_paging').setVisible(true);
            Ext.getCmp("legend_grid_column_host").setVisible(false);
            Ext.getCmp("legend_grid_column_service").setVisible(false);
            Ext.getCmp("legend_grid_column_metric").minWidth = 282;
        }


        if ((newValue === false) && (Ext.getStore('selected_objects').count() > 0)) {
            Ext.getCmp('generate_btn').setDisabled(false);
        }
    },

    onAdvanced_graphicsinpcCheckChange: function(menucheckitem, checked, eOpts) {
        if (checked === true) {
            Ext.getCmp("advanced_trendlines").setDisabled(true);
        } else {
            Ext.getCmp("advanced_trendlines").setDisabled(false);
        }

        var advanced_options = Ext.getCmp('advanced_options').query('menucheckitem');
        var counter_local = 0;
        var first_el = 0;
        Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Output')+': ');
        for (var i=0; i < advanced_options.length; i++) {
            if (advanced_options[i].checked === true && first_el === 0) {
                first_el++;
                //console.log(advanced_options[i]);
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + advanced_options[i].text);
            } else if (advanced_options[i].checked === true) {
                first_el++;
                //console.log(advanced_options[i]);
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + ' - ' + advanced_options[i].text);
            } else {
                counter_local++;
            }
        }
        if (counter_local === advanced_options.length) {
            Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Define Output'));
        }

    },

    onAdvanced_95pcCheckChange: function(menucheckitem, checked, eOpts) {

    },

    onAdvanced_autoscaleCheckChange: function(menucheckitem, checked, eOpts) {
        var advanced_options = Ext.getCmp('advanced_options').query('menucheckitem');
        var counter_local = 0;
        var first_el = 0;
        Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Output')+': ');
        for (var i=0; i < advanced_options.length; i++) {
            if (advanced_options[i].checked === true && first_el === 0) {
                first_el++;
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + advanced_options[i].text);
            } else if (advanced_options[i].checked === true) {
                first_el++;
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + ' - ' + advanced_options[i].text);
            } else {
                counter_local++;
            }
        }
        if (counter_local === advanced_options.length) {
            Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Define Output'));
        }

        var btn_autoscale = Ext.getCmp('legend_panel_button_autoscale');
        btn_autoscale.toggle(checked);
    },

    onAdvanced_thresholdsCheckChange: function(menucheckitem, checked, eOpts) {
        var advanced_options = Ext.getCmp('advanced_options').query('menucheckitem');
        var counter_local = 0;
        var first_el = 0;
        Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Output')+': ');
        for (var i=0; i < advanced_options.length; i++) {
            if (advanced_options[i].checked === true && first_el === 0) {
                first_el++;
                //console.log(advanced_options[i]);
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + advanced_options[i].text);
            } else if (advanced_options[i].checked === true) {
                first_el++;
                //console.log(advanced_options[i]);
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + ' - ' + advanced_options[i].text);
            } else {
                counter_local++;
            }
        }
        if (counter_local === advanced_options.length) {
            Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Define Output'));
        }


        var btn_thresholds = Ext.getCmp('legend_panel_button_thresholds');
        btn_thresholds.toggle(checked);
    },

    onAdvanced_trendlines_showalarmsCheckChange: function(menucheckitem, checked, eOpts) {
        var advanced_options = Ext.getCmp('advanced_options').query('menucheckitem');
        var counter_local = 0;
        var first_el = 0;
        Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Output')+': ');
        for (var i=0; i < advanced_options.length; i++) {
            if (advanced_options[i].checked === true && first_el === 0) {
                first_el++;
                //console.log(advanced_options[i]);
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + advanced_options[i].text);
            } else if (advanced_options[i].checked === true) {
                first_el++;
                //console.log(advanced_options[i]);
                current_title = Ext.getCmp('output_wrapper').title;
                Ext.getCmp('output_wrapper').setTitle(current_title + ' - ' + advanced_options[i].text);
            } else {
                counter_local++;
            }
        }
        if (counter_local === advanced_options.length) {
            Ext.getCmp('output_wrapper').setTitle('<span class="header-num">3</span> '+Ext.locale.translate('Define Output'));
        }

    },

    onCmbSelectedReportsSelect: function(combo, records, eOpts) {
        var selectedItems = Ext.getStore('selectedItems');
        var page = selectedItems.indexOf(records.shift()) + 1;
        Ext.getStore('service_paging').loadPage(page);
    },

    onMetrics_availableSelect: function(rowmodel, record, index, eOpts) {
        this.onMetricsAvailableSelectOrDeselect(rowmodel, record, index, eOpts);
    },

    onMetrics_availableDeselect: function(rowmodel, record, index, eOpts) {
        this.onMetricsAvailableSelectOrDeselect(rowmodel, record, index, eOpts);
    },

    onFirstSecondStepResize: function(component, width, height, oldWidth, oldHeight, eOpts) {
        //console.log(width);
    },

    applyAvailableFilter: function(field, newValue, oldValue, eOpts) {
        this.applyFilter(newValue);
    },

    applySelectedFilter: function(field, newValue, oldValue, eOpts) {
        var str = newValue;
        var filter_elements = Ext.getCmp('selected_elements');
        var filter_objects = Ext.getStore('selected_objects');
        if (str !== ''){
            Ext.app.Config.usingFilter = true;
            filter_objects.clearFilter(true);
            filter_objects.filter('name',new RegExp(str, "i"));
            filter_elements.setTitle(Ext.locale.translate('Objects Selected')+' - '+Ext.locale.translate('filtered'));
            filter_elements.removeBodyCls('grey-border');
            Ext.getCmp('filter_selected_toolbar').removeCls('grey-border');
            filter_elements.addCls('filter-border');
        } else {
            filter_elements.setTitle(Ext.locale.translate('Objects Selected'));
            filter_elements.removeCls('filter-border');
            filter_elements.addBodyCls('grey-border');
            Ext.getCmp('filter_selected_toolbar').addCls('grey-border');
            filter_objects.clearFilter();
            Ext.app.Config.usingFilter = false;
        }
    },

    onExportButtonClick: function(button, e, eOpts) {
        var config = Ext.app.Config.getOptions();

        var url;
        var custom_card = Ext.getCmp('custom_card');

        config.autoScale = castBooleanToString(Ext.getCmp('legend_panel_button_autoscale').pressed);
        config.showThresholdCp = castBooleanToString(Ext.getCmp('legend_panel_button_autoscale').pressed);

        if (/(tabular_)?export_pdf_button/.test(button.id)) {
            config.format = 'pdf';
            url = '/opmon/seagull/www/index.php/opexporter/action/genpdf';
        } else if (/(tabular_)?export_xml_button/.test(button.id)) {
            config.format = 'xml';
            url = '/opmon/seagull/www/index.php/opexporter/action/genxml';
        } else if (/(tabular_)?export_xls_button/.test(button.id)) {
            config.format = 'xls';
        } else if (button.id == 'export_png_button') {
            url = '/opmon/seagull/www/index.php/opexporter/action/genimage';
        }

        var success = function(o) {
            if (o.cacheurl) {
                window.open(o.cacheurl, "_blank");
            }
        };

        if (config.reportType === Ext.app.Config.CPGROUPBY || config.reportType === Ext.app.Config.CPDEFAULT) {
            if (config.aggregatedByMetric) {
                config.selectedItens = [config.currentSelectedItem];
            } else {
                config.selectedItens = [];

                Ext.getStore('selectedItems').each(function (item){
                    config.selectedItens.push(item.get('value'));
                });
            }

            config.objectType = Ext.app.Config.SERVICE;
        } else if (config.reportType === Ext.app.Config.CUSTOM) {
            url = '/opmon/seagull/www/index.php/opexporter/action/gencustomreport';
        }

        var params = {jsonData: config};
        Op.Reports.Utils.doHttpRequest(url,success,params);
    },

    onLegend_gridItemMouseEnter: function(dataview, record, item, index, e, eOpts) {
        this.highlightGraph(record.get('metric'));
    },

    onLegend_gridItemMouseLeave: function(dataview, record, item, index, e, eOpts) {
        if(this.metricColumnHighlight) {
            var chart = Ext.getCmp('graphic_container').chart.chart;
            chart.unhighlightGraph();
            this.metricColumnHighlight = false;
            this.cleanGraphCache();
        }
    },

    onLegend_gridContainerMouseOver: function(dataview, e, eOpts) {
        this.onLegend_gridItemMouseLeave();
    },

    onLegend_gridContainerMouseOut: function(dataview, e, eOpts) {
        this.onLegend_gridItemMouseLeave();
    },

    onLaunch: function() {
        if (Ext.app.Config.realtimeMode) {
            return;
        }
        var selected_elements = Ext.getCmp('selected_elements');
        if (selected_elements) {
            selected_elements.getView().refresh();
            this.resetReportScreen();
        }
    },

    resetReportScreen: function(name) {
        var me = this;
        if (!name) {
            name = Ext.locale.translate('New report');
            Ext.getCmp("saved_reports_combo").clearValue();
            Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/getreportinitial',function(o){
                var store_available = Ext.getStore('available_objects');
                store_available.removeAll();

                var store_selected = Ext.getStore('selected_objects');
                store_selected.removeAll();

                var host_selection_objects = Ext.getStore('host_selection_objects');
                host_selection_objects.removeAll();

                //time periods
                var timeperiods = Ext.getStore('timeperiods');
                timeperiods.removeAll();
                for (var i in o.timeperiods) {
                    timeperiods.add({name: o.timeperiods[i],value: i});
                }

                Ext.getCmp('period_field').setValue('last24hours');

                //timecuts
                var timecuts = Ext.getStore('timecuts');
                timecuts.removeAll();
                for (i in o.timecuts) {
                    timecuts.add({name: o.timecuts[i],value: i});
                }
                Ext.getCmp('timecut').setValue('100');

                //reports
                var savedreports = Ext.getStore('saved_reports');
                savedreports.removeAll();

                var savedreportsFresh = Object.keys(o.reports || {})
                        .map(function(key) {
                            return { name: o.reports[key], value: key };
                        })
                        .sort(function(first, second) {
                            return first.name.localeCompare(second.name);
                        });

                savedreports.loadData(savedreportsFresh);

                var reportform = Ext.getCmp("configuration_container");
                var config = Ext.app.Config.getOptions();

                reportform.getForm().setValues(config);

                //update adv options
                Ext.app.Config.setAdvOptions(config);

                if (me.onResetReady) {
                    me.onResetReady();
                }

            },{formTo: Ext.app.Config.CP});

            Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/getcontacts',function(o){
                //contacts
                var contacts = Ext.getStore('contacts');
                contacts.removeAll();
                var contacts_a = [];
                for (var i in o) {
                    contacts_a.push(o[i]);
                }
                contacts.loadData(contacts_a);
            },{formTo: Ext.app.Config.CP});

            Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/opreports/action/getcustomreports',function(o){
                var customreports = Ext.getStore('custom_reports');
                var custom_report_field = Ext.getCmp('custom_report_field');
                customreports.removeAll();
                for (var i in o) {
                    customreports.add({name: o[i].name,value: o[i].id});
                }
                if (customreports.count() > 0) {
                    custom_report_field.setValue(o[0].id);
                }
            },{dataset: Ext.app.Config.CP});
        }
        Ext.app.Config.reportOptions = undefined;
        Ext.getCmp("main_title").setValue("<h2>"+name+"</h2>");
        Ext.getCmp("output_wrapper").hide();
    },

    loadReport: function(id) {
        var me = this;
        Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/getsavedreport',function(o){
            delete o.vars;

            var report_name = o.reportName;
            me.resetReportScreen(report_name);
            var reportform = Ext.getCmp("configuration_container");
            var config = Ext.app.Config.setOptions(o);
            reportform.getForm().setValues(config);

            //update adv options
            Ext.app.Config.setAdvOptions(config);

            var selected_objects = Ext.getStore('selected_objects');

            var METRIC_ID = 2;
            var CONTAIN_METRIC_ID = 3;

            var selected_items = [];
            var selectedMetrics = [];
            var selectedObjectsHaveMetricId = false;

            var processValuesToHostGroupsAndServiceGroups = function (key) {
                Ext.getCmp("metricname_column").hide();
                if (parseInt(key)) {
                    Ext.getCmp("metricname_column").show();
                    selectedMetrics.push(key);
                    selectedObjectsHaveMetricId = true;
                } else {
                    selected_items.push({name: key, value: o.selectedItens[key]});
                }
            };

            var processValuesToHostAndServiceTypes = function(key) {

                var ids = o.selectedItens[key].split('!');
                selectedObjectsHaveMetricId = (ids.length === CONTAIN_METRIC_ID) || selectedObjectsHaveMetricId;

                if (selectedObjectsHaveMetricId) {
                    selectedMetrics.push(ids[METRIC_ID]);
                }

                Ext.getCmp("metricname_column").show();
                var fields = key.split('!');

                selected_items.push({hostname: fields[0], name: fields[1], value: o.selectedItens[key], metricname: fields[2]});

            };


            for (var key in o.selectedItens) {
                if (o.objectType === Ext.app.Config.SERVICE) {
                    processValuesToHostAndServiceTypes(key);
                } else {
                    processValuesToHostGroupsAndServiceGroups(key);
                }
            }

            selected_objects.loadData(selected_items);

            if (selectedObjectsHaveMetricId) {
                me.handlerMetricsAvailableStore(selectedMetrics);
                Ext.getCmp('aggregate_by_metric').setValue(true);
            } else {
                Ext.getCmp('aggregate_by_metric').setValue(false);
                Ext.getStore('metricsAvailable').removeAll();
            }

            Ext.getCmp('generate_btn').setDisabled(false);


            Ext.getCmp("email_container").getSelectionModel().deselectAll();
            Ext.getCmp("output_type").setValue(false);
            if ((o.contacts) && (o.contacts.length > 0)) {
                Ext.getCmp("output_type").setValue(true);
                var contacts = Ext.getStore('contacts');
                if (!Array.isArray(o.contacts)) {
                    o.contacts = [o.contacts];
                }
                for (var j = 0; j < o.contacts.length; j++) {

                }
                o.contacts.forEach(
                    function(element, index, array) {
                        for (var i = 0; i < contacts.data.items.length; i++) {
                            if (contacts.data.items[i].data.contact_id === element) {
                                Ext.getCmp("email_container").getSelectionModel().select(i, true);
                            }
                        }
                    }
                );
            }

            var store_selected = Ext.getStore('selected_objects');
            var selected_elements = Ext.getCmp("selected_elements");
            var selected_elements_num = store_selected.data.items.length;
            if (selected_elements_num !== 0) {
                Ext.getCmp("objects_wrapper").setTitle(Ext.String.format('<span class="header-num">2</span> {0} '+Ext.locale.translate('Elements Selected for the Report'),selected_elements_num));
                Ext.getCmp("output_wrapper").show();
            } else {
                Ext.getCmp("objects_wrapper").setTitle('<span class="header-num">2</span> '+Ext.locale.translate('Select the Report Objects'));
                Ext.getCmp("output_wrapper").hide();
            }


        },{id: id});
    },

    applyFilter: function(str) {
        var available_elements = Ext.getCmp('available_elements');
        var available_objects = Ext.getStore('available_objects');
        if (str !== ''){
            Ext.app.Config.usingFilter = true;
            available_objects.clearFilter(true);
            available_objects.filter('name',new RegExp(str, "i"));
            available_elements.setTitle(Ext.locale.translate('Objects Available')+' - '+Ext.locale.translate('filtered'));
            available_elements.removeBodyCls('grey-border');
            Ext.getCmp('filter_available_toolbar').removeCls('grey-border');
            available_elements.addCls('filter-border');
        } else {
            available_elements.setTitle(Ext.locale.translate('Objects Available'));
            available_elements.removeCls('filter-border');
            available_elements.addBodyCls('grey-border');
            Ext.getCmp('filter_available_toolbar').addCls('grey-border');
            available_objects.clearFilter();
            Ext.app.Config.usingFilter = false;
        }
    },

    saveReport: function(create) {
        var create = create || false;
        var me = this;
        var config = Ext.app.Config.getOptions(true);
        var success = function(o){
            if (o.output) {
                Ext.MessageBox.alert(Ext.locale.translate('Status'), Ext.locale.translate('Changes saved successfully.'));
                if (!config.id && config.reportName) {
                    var savedreports = Ext.getStore('saved_reports');
                    savedreports.add({name: config.reportName,value: o.output});
                    Ext.getCmp("saved_reports_combo").setValue(o.output);
                }
                me.loadReport(o.output);
            }
        };

        var action = function(btn, newname) {
            if (btn == 'yes' || btn == 'ok' && newname){
                if (btn == 'ok' && newname) {
                    config.reportName = newname;
                    config.id = "";
                }

                if (Ext.getCmp('aggregate_by_metric').getValue() && config.selectedItensDescription.length > 0) {
                    config.selectedItens = [];

                    config.selectedItensDescription.forEach(function (item) {
                        config.selectedItens = config.selectedItens.concat(item.value.split("!"));
                    });

                    var cmb = Ext.getCmp('object_type');
                    config.objectType = Ext.app.Config.SERVICE;
                    if (cmb.getValue() !== Ext.app.Config.HOST) {
                        config.objectType = cmb.getValue();
                        Ext.getStore('selected_objects').each(function(selected_item) {
                            config.selectedItens.push(selected_item.get('value'));
                        });
                    }
                }

                delete config.selectedItensDescription;

                if (config.reportType !== Ext.app.Config.CUSTOM){
                    delete config.customReport;
                }
                var params = {json: config};
                Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/savereport',success,params);
            }
        };
        if (create === false && config.id) {
            Ext.MessageBox.confirm(Ext.locale.translate('Confirm'), Ext.locale.translate('Save report ?'), action);
        } else {
            Ext.create('widget.save_report_popup').show();
        }
    },

    handlerMetricsAvailableStore: function(selectTheseMetrics) {
        var selectedItens = [];
        Ext.getStore('selected_objects').each(function(selected_item) {
            selectedItens.push(selected_item.get('value'));
        });

        var params = {
            jsonData: {
                selectedItens: selectedItens,
                objectType: Ext.getCmp('object_type').getValue()
            }
        };

        var grid = Ext.getCmp('metrics_available');
        var selectedMetrics = Ext.clone(grid.getSelectionModel().getSelection());
        grid.getSelectionModel().deselectAll();

        Ext.getCmp('metrics_counter').setText(Ext.locale.translate('There are no metrics selected yet'));

        var success = function(response) {

            var metricsAvailable = Ext.getStore('metricsAvailable');
            metricsAvailable.removeAll();
            metricsAvailable.clearData();
            metricsAvailable.add(response);

            selectTheseMetrics = selectTheseMetrics || [];

            metricsAvailable.each(function(metric) {
                Ext.each(selectTheseMetrics, function(id) {
                    var foundMetric = (metric.getId().indexOf(id) != -1);
                    if (foundMetric) {
                        grid.getSelectionModel().select(metric, true, true);
                        return false;
                    }
                });

                Ext.each(selectedMetrics, function(selectedMetric) {
                    var foundMetric = (metric.getId() == selectedMetric.getId());
                    if (foundMetric) {
                        grid.getSelectionModel().select(metric, true, true);
                        return false;
                    }
                });
            });
        };

        Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/getmetrics',success,params);
    },

    onMetricsAvailableSelectOrDeselect: function(rowmodel, record, index, eOpts) {
        var counterLabel = Ext.getCmp('metrics_counter');
        var selectedMetrics = rowmodel.getSelection();
        var selectedMetricsLength = selectedMetrics.length;
        var metricUnitAlert = Ext.getCmp('metric_unit_alert_container');
        var selectedUnits = [];
        var NOT_FOUND = -1;
        var MAX_SELECTED_UNITS = 2;

        for (var i in selectedMetrics) {
            if (selectedUnits.indexOf(selectedMetrics[i].get('unit')) == NOT_FOUND) {
                selectedUnits.push(selectedMetrics[i].get('unit'));
            }
        }

        var selectedUnitsLength = selectedUnits.length;

        counterLabel.setText(
            (selectedMetricsLength !== 0)
            ? Ext.String.format('{0} '+Ext.locale.translate('metric(s) selected')+'', selectedMetricsLength)
            : Ext.locale.translate('There are no metrics selected yet')
        );

        if (selectedUnitsLength > MAX_SELECTED_UNITS) {
            rowmodel.deselect(record);
            metricUnitAlert.show();
            return false;
        }

        metricUnitAlert.hide();
        Ext.getCmp('generate_btn').setDisabled((selectedMetrics.length <= 0));
        return true;
    },

    concatHostNameAndServiceDescription: function(record) {
        if (! record) return false;

        var report_is_a_service_type_and_record_wasnt_modified = (Ext.getCmp('object_type').getValue() === Ext.app.Config.SERVICE && (! record.dirty));

        if (report_is_a_service_type_and_record_wasnt_modified) {
            record.set('name', record.get('name'));
            record.set('hostname', Ext.getCmp('host_selection').getDisplayValue());
        }

        return true;
    },

    getGraph: function(metric) {
        this.chart = this.chart || Ext.getCmp('graphic_container').chart.chart;
        if(metric) {
            this.metricCached = metric;
        }
        return this.chart.getGraphById(this.metricCached);
    },

    cleanGraphCache: function() {
        this.metricCached = undefined;
    },

    highlightGraph: function(metric) {
        var graph = this.getGraph(metric);
        if(graph) {
            this.chart.highlightGraph();
            graph.changeOpacity(1);
            this.metricColumnHighlight = true;
        }
        else {
            this.onLegend_gridItemMouseLeave();
        }
    },

    init: function(application) {
        this.control({
            "#report_type_field": {
                change: this.onReportTypeChange
            },
            "#period_field": {
                change: this.onPeriodComboboxChange
            },
            "#period_from_date,#period_to_date": {
                beforerender: this.onDatefieldBeforeRender
            },
            "#period_from_date": {
                change: this.onPeriodFromDateChange
            },
            "#period_from_time,#period_to_time,#period_to_date": {
                change: this.onPeriodChange
            },
            "#period_to_date": {
                afterrender: this.onPeriodToDateAfterRender
            },
            "#period_last_type": {
                change: this.onPeriodLastTypeChange
            },
            "#object_type": {
                change: this.onObjectTypeChange
            },
            "#AvailableElementsGridView": {
                celldblclick: this.onAvailableElementsViewCellDblClick
            },
            "#host_selection": {
                change: this.onHostSelectionChange
            },
            "#SelectedElementsGridView": {
                celldblclick: this.onSelectedElementsViewCellDblClick
            },
            "#email_container": {
                select: this.onEmailContainerSelect,
                deselect: this.onEmailContainerDeselect
            },
            "#generate_btn": {
                click: this.onGenerateBtnClick
            },
            "#send_all_btn": {
                click: this.onSendAllBtnClick
            },
            "#send_one_btn": {
                click: this.onSendOneBtnClick
            },
            "#remove_one_btn": {
                click: this.onRemoveOneBtnClick
            },
            "#remove_all_btn": {
                click: this.onRemoveAllBtnClick
            },
            "#saved_reports_combo": {
                change: this.savedReportsComboboxChange
            },
            "#save_report": {
                click: this.onSaveReportClick
            },
            "#save_report_as": {
                click: this.onSaveReportAsClick
            },
            "#create_report": {
                click: this.onCreateReportClick
            },
            "#delete_report": {
                click: this.onDeleteReportClick
            },
            "#save_report_form_ok": {
                click: this.onSaveReportFormOkClick
            },
            "#custom_report_upload_button": {
                change: this.onCustomReportUploadChange
            },
            "#custom_report_upload": {
                afterrender: this.onCustomReportUploadAfterRender
            },
            "#custom_report_download_button": {
                click: this.onCustomReportDownloadButtonClick
            },
            "#custom_report_remove_button": {
                click: this.onCustomReportRemoveButtonClick
            },
            "#advanced_trendlines": {
                checkchange: this.onAdvanced_trendlinesCheckChange
            },
            "#advanced_futuretrend": {
                checkchange: this.onAdvanced_futuretrendCheckChange
            },
            "#advanced_absoluteminmax": {
                checkchange: this.onAdvanced_absoluteminmaxCheckChange
            },
            "#output_type": {
                change: this.onCheckboxfieldChange
            },
            "#aggregate_by_metric": {
                change: this.onAggregate_by_metricChange
            },
            "#advanced_graphicsinpc": {
                checkchange: this.onAdvanced_graphicsinpcCheckChange
            },
            "#advanced_95pc": {
                checkchange: this.onAdvanced_95pcCheckChange
            },
            "#advanced_autoscale": {
                checkchange: this.onAdvanced_autoscaleCheckChange
            },
            "#advanced_thresholds": {
                checkchange: this.onAdvanced_thresholdsCheckChange
            },
            "#advanced_trendlines_showalarms": {
                checkchange: this.onAdvanced_trendlines_showalarmsCheckChange
            },
            "#cmb_selected_reports": {
                select: this.onCmbSelectedReportsSelect
            },
            "#metrics_available": {
                select: this.onMetrics_availableSelect,
                deselect: this.onMetrics_availableDeselect
            },
            "#first_second_step": {
                resize: this.onFirstSecondStepResize
            },
            "#filter_available": {
                change: this.applyAvailableFilter
            },
            "#filter_selected": {
                change: this.applySelectedFilter
            },
            "#export_pdf_button, #export_xml_button, #export_png_button, #export_xls_button, #tabular_export_pdf_button, #tabular_export_xml_button, #tabular_export_xls_button": {
                click: this.onExportButtonClick
            },
            "#legend_grid": {
                itemmouseenter: this.onLegend_gridItemMouseEnter,
                itemmouseleave: this.onLegend_gridItemMouseLeave,
                containermouseover: this.onLegend_gridContainerMouseOver,
                containermouseout: this.onLegend_gridContainerMouseOut
            }
        });
    }

});
