/*
 * File: app/controller/RealtimeController.js
 *
 * This file was generated by Sencha Architect version 4.2.4.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Reports.controller.RealtimeController', {
    extend: 'Ext.app.Controller',

    refs: [
        {
            ref: 'realtimeview',
            selector: 'realtime_view'
        }
    ],

    onPlayPauseRealtimeClick: function(button, e, eOpts) {
        if (Ext.app.Config.realtimePlaying) {
            button.setIconCls('fa fa-play');
            Ext.app.Config.realtimePlaying = false;
            Ext.app.Config.realtimeWaitingResponse = false;
        } else {
            button.setIconCls('fa fa-pause');
            Ext.app.Config.realtimePlaying = true;
            this.playRealtime();
        }
    },

    onLaunch: function() {
        if (Ext.app.Config.realtimeMode) {
            this.loadOverviewContent(Ext.app.Config.originalReportOptions);

            Ext.getCmp("overview_container").layout.setActiveItem("overview_content");
            Ext.getCmp('overview_paging').setVisible(false);

            Ext.getCmp('overview_tab').setTitle(Ext.locale.translate('Realtime graph'));

            Ext.getCmp('overview_names_container').show();
            Ext.getCmp('overview_period_container').hide();
            Ext.getCmp('cmb_selected_reports').hide();

            Ext.getCmp('period_field_report').hide();
            Ext.getCmp('timecut_report').hide();
            Ext.getCmp('options_container1').show();
            Ext.getCmp('realtime_container').show();
            Ext.getCmp('graphic_container').setMargin('-7 0 0 0');
            Ext.getCmp('height_space_legend').hide();
            Ext.getCmp('legends_expand').hide();
        }
    },

    loadOverviewContent: function(item) {
        if (!item) {
            return;
        }
        var me = this;
        var graphic_container = Ext.getCmp('graphic_container');
        Ext.getCmp('overview_footer').hide();

        var config = Ext.app.Config.getOptions();
        config.selectedItens = [item.value];
        config.objectType = Ext.app.Config.SERVICE;
        Ext.app.Config.setOptions({currentSelectedItem: item.value});

        var fconfig = Ext.clone(config);
        fconfig.host_name = item.host_name;
        fconfig.service_description = item.service_description;
        fconfig.current_period = '';
        fconfig.current_duration = 'realtime';

        Ext.getCmp('info_form_container').getForm().reset();
        Ext.getCmp('info_form_container').getForm().setValues(fconfig);
        Ext.getCmp('realtime_period_container').getForm().reset();
        Ext.getCmp('realtime_period_container').getForm().setValues(fconfig);

        var metricStore = Ext.getStore('metric_store');

        this.success = function(o) {
            Ext.app.Config.realtimeWaitingResponse = false;

            var d = me.convertReatimeToCp(o);

            if ((d !== undefined) && d.cpdata && d.cpdata.length > 0) {
                me.setOverviewNoData(false);

                var chart;

                if (graphic_container.chart) {
                    chart = graphic_container.chart;
                } else {
                    chart = new Op.Reports.SerialChart({containerId:'graphic_container'});
                    graphic_container.chart = chart;
                    chart.setAutoScale(true);
                    Ext.getCmp('legend_panel_button_autoscale').toggle(!chart.getAutoScale());
                    chart.setThresholdsGuide(false);
                    Ext.getCmp('legend_panel_button_thresholds').toggle(!chart.getThresholdsGuide());
                }

                graphic_container.chart.setData(d);

                config.host_name = d.host_name;
                config.service_description = d.service_description;

                d.tsBegin = d.cpdata[0].date;
                d.tsEnd = d.cpdata[d.cpdata.length - 1].date;

                config.current_period = Ext.Date.format(d.tsBegin, Ext.app.Config.LONG_DATE_FORMAT)+' '+Ext.locale.translate('to')+' '+Ext.Date.format(d.tsEnd, Ext.app.Config.LONG_DATE_FORMAT);
                config.current_duration = 'realtime';

                Ext.getCmp('realtime_period_container').getForm().setValues(config);

                var cpdata = graphic_container.chart.getData().cpdata;
                var metric_data = me.addMetricInStore(d);

                metricStore.add(metric_data);

                Reports.app.getController('MainController').highlightGraph();

            } else {
                me.setOverviewNoData(true);
            }

            me.playRealtime(item);
        };

        this.playRealtime(item);
    },

    convertReatimeToCp: function(data) {
        if (data === undefined || !data.hasOwnProperty('data')) {
            return undefined;
        }

        var cp = {};
        cp.host_id = data.host_id;
        cp.host_name = data.host_name;
        cp.service_id = data.service_id;
        cp.service_description = data.service_description;

        cp.cpdata_min = [];
        cp.cpdata_max = [];
        cp.cpdata_avg = [];
        cp.cpdata_warn = [];
        cp.cpdata_critical = [];
        cp.cpdata_last = [];
        cp.cpdata_perc95 = [];
        cp.unit = [];
        cp.metric = [];
        cp.limits = {min:[],max:[]};
        cp.cpdata = [];

        var cpdata = {};

        var max = {};
        var min = {};

        for (var m in data.data) {
            cp.metric.push(data.data[m].metric);
            cp.cpdata_avg.push(null);
            cp.cpdata_warn.push(parseFloat(data.data[m].warning));
            cp.cpdata_critical.push(parseFloat(data.data[m].critical));
            cp.cpdata_last.push([parseFloat(data.data[m].value)]);
            cp.cpdata_perc95.push(null);
            cp.unit.push(data.data[m].unit);
            cp.limits.max.push(parseFloat(data.data[m].max));
            cp.limits.min.push(parseFloat(data.data[m].min));
            cp.cpdata_min.push(null);
            cp.cpdata_max.push(null);
            cpdata[data.data[m].metric] = parseFloat(data.data[m].value);
        }

        if (cp.metric.length === 0) {
            return undefined;
        }

        if (Ext.app.Config.realtimeDataProvider.length > Ext.app.Config.realtimeNumSamples) {
            Ext.app.Config.realtimeDataProvider.shift();
        }

        if (Ext.app.Config.realtimeDataProvider.length) {
            var size = Ext.app.Config.realtimeDataProvider.length;
            var last = Ext.app.Config.realtimeDataProvider[size - 1];

            for(var key in last) {
                if (key !== 'date' && ! cpdata[key]) {
                    cpdata[key] = null;
                    cp.metric.push(key);
                    cp.unit.push("");
                }
            }
        }

        cpdata.date = Date.now() / 1000 | 0;

        Ext.app.Config.realtimeDataProvider.push(Ext.clone(cpdata));

        Ext.app.Config.realtimeDataProvider.forEach(function(el,index){
            for (var m in el) {
                var ind = cp.metric.indexOf(m);
                if (m !== 'date') {
                    if (cp.cpdata_min[ind] === null || el[m] < cp.cpdata_min[ind]) {
                        cp.cpdata_min[ind] = el[m];
                    }
                    if (cp.cpdata_max[ind] === null || el[m] > cp.cpdata_max[ind]) {
                        cp.cpdata_max[ind] = el[m];
                    }
                }
            }
        });

        cp.cpdata = Ext.clone(Ext.app.Config.realtimeDataProvider);

        return cp;
    },

    setOverviewNoData: function(visible) {
        visible = (visible === undefined || visible) ? true : false;
        Ext.getCmp('graphic_container').setVisible(!visible);
        Ext.getCmp('legend_grid').setVisible(!visible);
        Ext.getCmp('overview_nodata_content').setVisible(visible);
    },

    playRealtime: function(item) {
        this.item = this.item || item;
        setTimeout(function() {
            if (Ext.app.Config.realtimePlaying && !Ext.app.Config.realtimeWaitingResponse){
                Ext.app.Config.realtimeWaitingResponse = true;
                var graphic_container = Ext.getCmp('graphic_container');
                var useLoading = (graphic_container.chart) ? false : true;
                var params = {mod: 'REALTIME',service_id: this.item.service_id,host_id: this.item.host_id};
                Op.Reports.Utils.doHttpRequest('/opmon/seagull/www/index.php/wsconnector/action/runservicecheck',this.success,params,true,useLoading);
            }
        }.bind(this), Ext.app.Config.realtimeUpdateInterval);
    },

    addMetricInStore: function(data) {
        var metricStore = Ext.getStore('metric_store');
        var cp_color = new Colors();
        var m_color = cp_color.getCPColors();

        return data.metric
        .filter(function(metric) {
            return metricStore.findExact('metric', metric) === -1;
        })
        .map(function(metric, i) {
            return {
                color   : m_color[ (metricStore.getCount() + i) % cp_color.cpColorsAvailable() ],
                metric  : metric,
                max     : data.cpdata_max[i],
                min     : data.cpdata_min[i],
                avg     : data.cpdata_avg[i],
                last    : data.cpdata_last[i],
                unit    : data.unit[i]
            };
        });
    },

    init: function(application) {
        this.control({
            "#play_pause_realtime": {
                click: this.onPlayPauseRealtimeClick
            }
        });
    }

});
