/*
 * File: app/view/MainView.js
 *
 * This file was generated by Sencha Architect version 4.2.4.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Reports.view.MainView', {
    extend: 'Ext.container.Viewport',

    requires: [
        'Reports.view.TextClearField',
        'Reports.view.OverviewContent',
        'Ext.form.field.Display',
        'Ext.toolbar.Toolbar',
        'Ext.toolbar.Separator',
        'Ext.button.Split',
        'Ext.menu.Menu',
        'Ext.form.Panel',
        'Ext.form.field.File',
        'Ext.form.field.FileButton',
        'Ext.form.FieldContainer',
        'Ext.form.field.Number',
        'Ext.form.field.Date',
        'Ext.form.field.Time',
        'Ext.grid.Panel',
        'Ext.grid.View',
        'Ext.grid.column.Number',
        'Ext.selection.CheckboxModel',
        'Ext.form.Label',
        'Ext.grid.plugin.BufferedRenderer',
        'Ext.toolbar.Spacer',
        'Ext.form.field.Checkbox',
        'Ext.menu.CheckItem',
        'Ext.tab.Panel',
        'Ext.tab.Tab',
        'Ext.app.Dashboard'
    ],

    id: 'main_view',

    layout: {
        type: 'vbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'container',
                    cls: 'grey-bg',
                    id: 'header',
                    layout: {
                        type: 'hbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'container',
                            flex: 1,
                            id: 'title_container',
                            items: [
                                {
                                    xtype: 'displayfield',
                                    id: 'main_title',
                                    margin: '1 0 0 15',
                                    fieldLabel: '',
                                    name: 'reportName',
                                    value: ''
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            id: 'toolbarcard',
                            layout: 'card',
                            items: [
                                {
                                    xtype: 'toolbar',
                                    cls: 'grey-bg',
                                    id: 'crud_bar',
                                    padding: 10,
                                    items: [
                                        {
                                            xtype: 'combobox',
                                            id: 'saved_reports_combo',
                                            width: 200,
                                            fieldLabel: '',
                                            labelWidth: 120,
                                            emptyText: Ext.locale.translate('Open a saved report...'),
                                            autoSelect: false,
                                            displayField: 'name',
                                            queryMode: 'local',
                                            store: 'saved_reports',
                                            valueField: 'value'
                                        },
                                        {
                                            xtype: 'tbseparator'
                                        },
                                        {
                                            xtype: 'splitbutton',
                                            disabled: true,
                                            id: 'save_report',
                                            iconCls: 'fa fa-save icon-btn-small-rp icon-half-black',
                                            text: Ext.locale.translate('Save this report'),
                                            menu: {
                                                xtype: 'menu',
                                                width: 120,
                                                items: [
                                                    {
                                                        xtype: 'menuitem',
                                                        id: 'save_report_as',
                                                        text: Ext.locale.translate('Save as...')
                                                    }
                                                ]
                                            }
                                        },
                                        {
                                            xtype: 'button',
                                            id: 'delete_report',
                                            iconCls: 'fa fa-remove icon-btn-small-rp icon-red',
                                            text: Ext.locale.translate('Delete this report')
                                        },
                                        {
                                            xtype: 'tbseparator'
                                        },
                                        {
                                            xtype: 'button',
                                            id: 'create_report',
                                            iconCls: 'fa fa-plus icon-btn-small-rp icon-green',
                                            text: Ext.locale.translate('Create new report')
                                        }
                                    ]
                                },
                                {
                                    xtype: 'toolbar',
                                    cls: 'grey-bg',
                                    id: 'graphic_tools',
                                    items: [
                                        {
                                            xtype: 'button',
                                            hidden: true,
                                            id: 'favorite_btn',
                                            iconCls: 'fa fa-star-o icon-btn-small-rp icon-yellow',
                                            text: Ext.locale.translate('Favorite this')
                                        },
                                        {
                                            xtype: 'container',
                                            cls: 'o-btn-group',
                                            id: 'toggle_detail_btn',
                                            padding: 0,
                                            items: [
                                                {
                                                    xtype: 'button',
                                                    cls: 'o-left-btn',
                                                    id: 'overview_btn',
                                                    margin: 0,
                                                    enableToggle: true,
                                                    pressed: true,
                                                    text: Ext.locale.translate('Overview')
                                                },
                                                {
                                                    xtype: 'button',
                                                    cls: 'o-right-btn',
                                                    id: 'detailed_btn',
                                                    margin: 0,
                                                    enableToggle: true,
                                                    text: Ext.locale.translate('Detailed')
                                                }
                                            ]
                                        },
                                        {
                                            xtype: 'tbseparator',
                                            hidden: true
                                        },
                                        {
                                            xtype: 'tbseparator'
                                        },
                                        {
                                            xtype: 'button',
                                            handler: function(button, e) {
                                                Reports.getApplication().getController('DefaultController').clearOldChart();

                                                Ext.getCmp("card_container").layout.setActiveItem("configuration_card");
                                                Ext.getCmp("toolbarcard").layout.setActiveItem("crud_bar");
                                            },
                                            iconCls: 'fa fa-chevron-left icon-btn-small-rp icon-half-black',
                                            text: Ext.locale.translate('Back')
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                },
                {
                    xtype: 'container',
                    flex: 1,
                    id: 'card_container',
                    layout: 'card',
                    items: [
                        {
                            xtype: 'panel',
                            id: 'configuration_card',
                            layout: 'card',
                            bodyCls: 'ax-tab-bar-default',
                            bodyPadding: '0 0 15 0',
                            items: [
                                {
                                    xtype: 'container',
                                    id: 'first_second_step',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch'
                                    },
                                    items: [
                                        {
                                            xtype: 'form',
                                            cls: 'oppanel',
                                            id: 'configuration_container',
                                            width: 255,
                                            bodyPadding: '11 14 15',
                                            animCollapse: false,
                                            collapseDirection: 'right',
                                            collapseFirst: false,
                                            collapsible: true,
                                            frameHeader: false,
                                            title: '<span class="header-num">1</span> '+Ext.locale.translate('Configure the Report')+'',
                                            titleCollapse: true,
                                            items: [
                                                {
                                                    xtype: 'combobox',
                                                    anchor: '100%',
                                                    id: 'report_type_field',
                                                    fieldLabel: Ext.locale.translate('Layout'),
                                                    labelAlign: 'top',
                                                    labelSeparator: ' ',
                                                    labelWidth: 50,
                                                    name: 'reportType',
                                                    value: '0',
                                                    editable: false,
                                                    displayField: 'name',
                                                    forceSelection: true,
                                                    queryMode: 'local',
                                                    store: 'report_type',
                                                    valueField: 'value'
                                                },
                                                {
                                                    xtype: 'container',
                                                    hidden: true,
                                                    id: 'custom_report_container',
                                                    layout: {
                                                        type: 'vbox',
                                                        align: 'stretch'
                                                    },
                                                    items: [
                                                        {
                                                            xtype: 'combobox',
                                                            id: 'custom_report_field',
                                                            width: 185,
                                                            fieldLabel: '',
                                                            hideLabel: true,
                                                            labelWidth: 0,
                                                            name: 'customReport',
                                                            emptyText: Ext.locale.translate('Select a custom report...'),
                                                            enforceMaxLength: false,
                                                            editable: false,
                                                            matchFieldWidth: false,
                                                            displayField: 'name',
                                                            forceSelection: true,
                                                            growToLongestValue: false,
                                                            queryMode: 'local',
                                                            store: 'custom_reports',
                                                            valueField: 'value'
                                                        },
                                                        {
                                                            xtype: 'container',
                                                            flex: 1,
                                                            id: 'customActionButtons',
                                                            layout: {
                                                                type: 'hbox',
                                                                align: 'stretch'
                                                            },
                                                            items: [
                                                                {
                                                                    xtype: 'container',
                                                                    flex: 1
                                                                },
                                                                {
                                                                    xtype: 'filefield',
                                                                    id: 'custom_report_upload',
                                                                    padding: '0 0 0 5',
                                                                    fieldLabel: Ext.locale.translate('Label'),
                                                                    hideLabel: true,
                                                                    labelWidth: 0,
                                                                    size: 0,
                                                                    buttonOnly: true,
                                                                    buttonText: '',
                                                                    buttonConfig: {
                                                                        xtype: 'filebutton',
                                                                        cls: 'x-form-file-btn grey-border grey-bg',
                                                                        id: 'custom_report_upload_button',
                                                                        margin: '0 2 0 0',
                                                                        padding: '5 3 1',
                                                                        iconCls: 'fa fa-upload icon-btn-small-rp icon-half-black',
                                                                        tooltip: Ext.locale.translate('Upload new custom report')
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'button',
                                                                    cls: 'grey-border grey-bg',
                                                                    disabled: true,
                                                                    id: 'custom_report_download_button',
                                                                    margin: '0 2',
                                                                    padding: '5 3 1',
                                                                    iconCls: 'fa fa-download icon-btn-small-rp icon-half-black',
                                                                    tooltip: Ext.locale.translate('Download the custom report')
                                                                },
                                                                {
                                                                    xtype: 'button',
                                                                    cls: 'grey-border grey-bg',
                                                                    disabled: true,
                                                                    id: 'custom_report_remove_button',
                                                                    margin: '0 0 0 2',
                                                                    padding: '4 3 2',
                                                                    iconCls: 'fa fa-remove icon-btn-small-rp icon-half-black',
                                                                    tooltip: Ext.locale.translate('Delete the custom report')
                                                                }
                                                            ],
                                                            listeners: {
                                                                afterrender: {
                                                                    fn: me.onCustomActionButtonsAfterRender,
                                                                    scope: me
                                                                }
                                                            }
                                                        }
                                                    ]
                                                },
                                                {
                                                    xtype: 'combobox',
                                                    anchor: '100%',
                                                    hidden: true,
                                                    id: 'groupedby_field',
                                                    fieldLabel: Ext.locale.translate('Method'),
                                                    labelSeparator: ' ',
                                                    labelWidth: 44,
                                                    name: 'groupbySelectMethod',
                                                    emptyText: Ext.locale.translate('Select a method for group by...'),
                                                    editable: false,
                                                    displayField: 'name',
                                                    forceSelection: true,
                                                    queryMode: 'local',
                                                    store: 'groupedby',
                                                    valueField: 'value'
                                                },
                                                {
                                                    xtype: 'combobox',
                                                    anchor: '100%',
                                                    id: 'period_field',
                                                    fieldLabel: Ext.locale.translate('Period'),
                                                    labelAlign: 'top',
                                                    labelSeparator: ' ',
                                                    labelWidth: 50,
                                                    name: 'reportPeriod',
                                                    value: 'last24hours',
                                                    emptyText: Ext.locale.translate('Select period...'),
                                                    editable: false,
                                                    displayField: 'name',
                                                    forceSelection: true,
                                                    queryMode: 'local',
                                                    store: 'timeperiods',
                                                    valueField: 'value'
                                                },
                                                {
                                                    xtype: 'fieldcontainer',
                                                    hidden: true,
                                                    id: 'period_last',
                                                    margin: '0 0 5 48',
                                                    fieldLabel: '',
                                                    labelWidth: 50,
                                                    layout: {
                                                        type: 'hbox',
                                                        align: 'middle'
                                                    },
                                                    items: [
                                                        {
                                                            xtype: 'numberfield',
                                                            id: 'period_last_number',
                                                            margin: '0 5 0 0',
                                                            width: 65,
                                                            fieldLabel: '',
                                                            name: 'timeCounter',
                                                            value: 1,
                                                            maxValue: 365,
                                                            minValue: 1
                                                        },
                                                        {
                                                            xtype: 'combobox',
                                                            flex: 1,
                                                            frame: false,
                                                            id: 'period_last_type',
                                                            fieldLabel: '',
                                                            name: 'timeUnit',
                                                            value: 'days',
                                                            editable: false,
                                                            displayField: 'name',
                                                            queryMode: 'local',
                                                            store: 'period_last_types',
                                                            valueField: 'value'
                                                        }
                                                    ]
                                                },
                                                {
                                                    xtype: 'fieldcontainer',
                                                    hidden: true,
                                                    id: 'period_from',
                                                    fieldLabel: Ext.locale.translate('From'),
                                                    labelSeparator: ' ',
                                                    labelWidth: 44,
                                                    layout: {
                                                        type: 'hbox',
                                                        align: 'middle'
                                                    },
                                                    items: [
                                                        {
                                                            xtype: 'datefield',
                                                            id: 'period_from_date',
                                                            margin: '0 5 0 0',
                                                            width: 104,
                                                            fieldLabel: '',
                                                            name: 'dateFrom',
                                                            value: '15-10-2015',
                                                            allowBlank: false,
                                                            format: 'd-m-Y'
                                                        },
                                                        {
                                                            xtype: 'timefield',
                                                            flex: 1,
                                                            frame: false,
                                                            id: 'period_from_time',
                                                            maxWidth: 100,
                                                            width: 60,
                                                            fieldLabel: '',
                                                            name: 'timeFrom',
                                                            value: '00:00',
                                                            allowBlank: false,
                                                            format: 'H:i'
                                                        }
                                                    ]
                                                },
                                                {
                                                    xtype: 'fieldcontainer',
                                                    hidden: true,
                                                    id: 'period_to',
                                                    margin: '0 0 10 0',
                                                    fieldLabel: Ext.locale.translate('To'),
                                                    labelSeparator: ' ',
                                                    labelWidth: 44,
                                                    layout: {
                                                        type: 'hbox',
                                                        align: 'middle'
                                                    },
                                                    items: [
                                                        {
                                                            xtype: 'datefield',
                                                            cls: 'date-time-constrains',
                                                            id: 'period_to_date',
                                                            margin: '0 5 0 0',
                                                            width: 104,
                                                            fieldLabel: '',
                                                            name: 'dateTo',
                                                            allowBlank: false,
                                                            format: 'd-m-Y'
                                                        },
                                                        {
                                                            xtype: 'timefield',
                                                            flex: 1,
                                                            id: 'period_to_time',
                                                            fieldLabel: '',
                                                            name: 'timeTo',
                                                            value: '23:59',
                                                            allowBlank: false,
                                                            format: 'H:i'
                                                        }
                                                    ]
                                                },
                                                {
                                                    xtype: 'combobox',
                                                    anchor: '100%',
                                                    id: 'timecut',
                                                    fieldLabel: Ext.locale.translate('Timecut'),
                                                    labelAlign: 'top',
                                                    labelSeparator: ' ',
                                                    labelWidth: 50,
                                                    name: 'timeCutId',
                                                    emptyText: Ext.locale.translate('Select a timecut...'),
                                                    editable: false,
                                                    displayField: 'name',
                                                    forceSelection: true,
                                                    queryMode: 'local',
                                                    store: 'timecuts',
                                                    valueField: 'value'
                                                },
                                                {
                                                    xtype: 'combobox',
                                                    anchor: '100%',
                                                    id: 'object_type',
                                                    fieldLabel: Ext.locale.translate('Object'),
                                                    labelAlign: 'top',
                                                    labelSeparator: ' ',
                                                    labelWidth: 50,
                                                    name: 'objectType',
                                                    emptyText: Ext.locale.translate('Select an object type...'),
                                                    editable: false,
                                                    displayField: 'name',
                                                    forceSelection: true,
                                                    queryMode: 'local',
                                                    store: 'object_type',
                                                    valueField: 'value'
                                                }
                                            ]
                                        },
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            id: 'right_card_container',
                                            layout: 'card',
                                            items: [
                                                {
                                                    xtype: 'container',
                                                    html: '<i class=\'fa fa-arrow-left\' style=\'color: #bbb; display: block; float: left; font-size: 30px;\'></i><div style=\'color: #bbb; padding-right: 20px; line-height: 35px; font-size: 20px; margin-left: 10px; display: block; float: left;\'>'+Ext.locale.translate('Start setting your report here')+'</div>',
                                                    id: 'pointer_card',
                                                    padding: '77 0 0',
                                                    width: 300
                                                },
                                                {
                                                    xtype: 'container',
                                                    id: 'content_card',
                                                    margin: '0 15 0 5',
                                                    layout: 'border',
                                                    items: [
                                                        {
                                                            xtype: 'panel',
                                                            region: 'center',
                                                            cls: 'oppanel',
                                                            id: 'objects_wrapper',
                                                            bodyPadding: '0 14 0',
                                                            placeholder: 'Default',
                                                            title: '<span class="header-num">2</span> '+Ext.locale.translate('Select the Report Objects')+'',
                                                            layout: {
                                                                type: 'hbox',
                                                                align: 'stretch'
                                                            },
                                                            items: [
                                                                {
                                                                    xtype: 'gridpanel',
                                                                    flex: 5,
                                                                    cls: 'opsubpanel',
                                                                    id: 'available_elements',
                                                                    bodyCls: 'grey-bg grey-border no-border-top',
                                                                    title: Ext.locale.translate('Objects Available'),
                                                                    allowDeselect: true,
                                                                    enableColumnHide: false,
                                                                    enableColumnMove: false,
                                                                    enableColumnResize: false,
                                                                    hideHeaders: true,
                                                                    rowLines: false,
                                                                    scroll: 'vertical',
                                                                    store: 'available_objects',
                                                                    columns: [
                                                                        {
                                                                            xtype: 'gridcolumn',
                                                                            border: 0,
                                                                            sortable: false,
                                                                            dataIndex: 'name',
                                                                            text: 'String',
                                                                            tooltip: Ext.locale.translate('Double-click to add to selection'),
                                                                            flex: 1
                                                                        }
                                                                    ],
                                                                    viewConfig: {
                                                                        id: 'AvailableElementsGridView',
                                                                        deferEmptyText: false,
                                                                        emptyText: Ext.locale.translate('There is no object available')
                                                                    },
                                                                    dockedItems: [
                                                                        {
                                                                            xtype: 'toolbar',
                                                                            dock: 'top',
                                                                            cls: 'silver-grey-bg',
                                                                            hidden: true,
                                                                            id: 'host_selection_wrapper',
                                                                            items: [
                                                                                {
                                                                                    xtype: 'combobox',
                                                                                    flex: 1,
                                                                                    id: 'host_selection',
                                                                                    fieldLabel: Ext.locale.translate('Host'),
                                                                                    labelWidth: 35,
                                                                                    anyMatch: true,
                                                                                    displayField: 'name',
                                                                                    forceSelection: true,
                                                                                    queryMode: 'local',
                                                                                    store: 'host_selection_objects',
                                                                                    valueField: 'value'
                                                                                }
                                                                            ]
                                                                        },
                                                                        {
                                                                            xtype: 'toolbar',
                                                                            dock: 'top',
                                                                            cls: 'grey-bg grey-border no-border-bottom',
                                                                            id: 'filter_available_toolbar',
                                                                            padding: '8 0 8 8',
                                                                            items: [
                                                                                {
                                                                                    xtype: 'textclearfield',
                                                                                    id: 'filter_available',
                                                                                    width: 100,
                                                                                    flex: 1
                                                                                }
                                                                            ]
                                                                        }
                                                                    ],
                                                                    selModel: Ext.create('Ext.selection.RowModel', {
                                                                        allowDeselect: true,
                                                                        mode: 'MULTI'
                                                                    })
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    id: 'select_container',
                                                                    maxWidth: 100,
                                                                    minWidth: 60,
                                                                    layout: {
                                                                        type: 'vbox',
                                                                        align: 'center'
                                                                    },
                                                                    items: [
                                                                        {
                                                                            xtype: 'container',
                                                                            flex: 1
                                                                        },
                                                                        {
                                                                            xtype: 'toolbar',
                                                                            padding: 0,
                                                                            items: [
                                                                                {
                                                                                    xtype: 'button',
                                                                                    id: 'send_all_btn',
                                                                                    margin: '0 0 2',
                                                                                    width: 34,
                                                                                    iconAlign: 'top',
                                                                                    iconCls: 'fa fa-angle-double-right icon-size-two icon-btn-medium-rp icon-half-black',
                                                                                    scale: 'medium',
                                                                                    text: ''
                                                                                }
                                                                            ]
                                                                        },
                                                                        {
                                                                            xtype: 'button',
                                                                            id: 'send_one_btn',
                                                                            margin: '2 0',
                                                                            width: 34,
                                                                            iconCls: 'fa fa-angle-right icon-size-two icon-btn-medium-rp icon-white',
                                                                            scale: 'medium',
                                                                            text: ''
                                                                        },
                                                                        {
                                                                            xtype: 'button',
                                                                            id: 'remove_one_btn',
                                                                            margin: '2 0',
                                                                            width: 34,
                                                                            iconCls: 'fa fa-angle-left icon-size-two icon-btn-medium-rp icon-white',
                                                                            scale: 'medium',
                                                                            text: ''
                                                                        },
                                                                        {
                                                                            xtype: 'toolbar',
                                                                            padding: 0,
                                                                            items: [
                                                                                {
                                                                                    xtype: 'button',
                                                                                    cls: 'x-btn-default-toolbar-medium',
                                                                                    id: 'remove_all_btn',
                                                                                    margin: '2 0 0',
                                                                                    width: 35,
                                                                                    iconCls: 'fa fa-angle-double-left icon-size-two icon-btn-medium-rp icon-half-black',
                                                                                    scale: 'medium',
                                                                                    text: ''
                                                                                }
                                                                            ]
                                                                        },
                                                                        {
                                                                            xtype: 'container',
                                                                            flex: 1
                                                                        }
                                                                    ]
                                                                },
                                                                {
                                                                    xtype: 'gridpanel',
                                                                    flex: 7,
                                                                    cls: 'opsubpanel',
                                                                    id: 'selected_elements',
                                                                    margin: 0,
                                                                    bodyCls: 'grey-bg grey-border no-border-top',
                                                                    title: Ext.locale.translate('Objects Selected'),
                                                                    allowDeselect: true,
                                                                    columnLines: true,
                                                                    enableColumnHide: false,
                                                                    enableColumnMove: false,
                                                                    enableColumnResize: false,
                                                                    hideHeaders: true,
                                                                    rowLines: false,
                                                                    scroll: 'vertical',
                                                                    store: 'selected_objects',
                                                                    columns: [
                                                                        {
                                                                            xtype: 'gridcolumn',
                                                                            renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                                                                                metaData.tdAttr = 'data-qtip="' + value + '"';
                                                                                return value;
                                                                            },
                                                                            hidden: true,
                                                                            id: 'hostname_column',
                                                                            dataIndex: 'hostname',
                                                                            text: 'hostname',
                                                                            flex: 3
                                                                        },
                                                                        {
                                                                            xtype: 'gridcolumn',
                                                                            renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                                                                                metaData.tdAttr = 'data-qtip="' + value + '"';
                                                                                return value;
                                                                            },
                                                                            dataIndex: 'name',
                                                                            text: 'String',
                                                                            tooltip: Ext.locale.translate('Double-click to remove the item of selection'),
                                                                            flex: 4
                                                                        },
                                                                        {
                                                                            xtype: 'gridcolumn',
                                                                            id: 'metricname_column',
                                                                            dataIndex: 'metricname',
                                                                            text: 'metricname_column'
                                                                        }
                                                                    ],
                                                                    viewConfig: {
                                                                        id: 'SelectedElementsGridView',
                                                                        deferEmptyText: false,
                                                                        emptyText: Ext.locale.translate('There is no object selected')
                                                                    },
                                                                    dockedItems: [
                                                                        {
                                                                            xtype: 'toolbar',
                                                                            dock: 'top',
                                                                            cls: 'grey-bg',
                                                                            hidden: true,
                                                                            id: 'host_selection_wrapper1',
                                                                            items: [
                                                                                {
                                                                                    xtype: 'combobox',
                                                                                    flex: 1,
                                                                                    fieldLabel: '',
                                                                                    emptyText: Ext.locale.translate('Select the host...')
                                                                                }
                                                                            ]
                                                                        },
                                                                        {
                                                                            xtype: 'toolbar',
                                                                            dock: 'top',
                                                                            cls: 'grey-bg grey-border no-border-bottom',
                                                                            id: 'filter_selected_toolbar',
                                                                            padding: '8 0 8 8',
                                                                            items: [
                                                                                {
                                                                                    xtype: 'textclearfield',
                                                                                    id: 'filter_selected',
                                                                                    width: 100,
                                                                                    flex: 1
                                                                                }
                                                                            ]
                                                                        }
                                                                    ],
                                                                    selModel: Ext.create('Ext.selection.RowModel', {
                                                                        allowDeselect: true,
                                                                        mode: 'MULTI'
                                                                    })
                                                                },
                                                                {
                                                                    xtype: 'gridpanel',
                                                                    flex: 10,
                                                                    cls: 'opsubpanel',
                                                                    hidden: true,
                                                                    id: 'metrics_available',
                                                                    margin: '0 0 0 10',
                                                                    bodyCls: 'grey-bg grey-border',
                                                                    title: Ext.locale.translate('Metrics Available'),
                                                                    allowDeselect: true,
                                                                    enableColumnHide: false,
                                                                    enableColumnMove: false,
                                                                    scroll: 'vertical',
                                                                    store: 'metricsAvailable',
                                                                    columns: [
                                                                        {
                                                                            xtype: 'numbercolumn',
                                                                            width: 45,
                                                                            align: 'right',
                                                                            dataIndex: 'quantity',
                                                                            text: '#',
                                                                            format: '0'
                                                                        },
                                                                        {
                                                                            xtype: 'gridcolumn',
                                                                            renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                                                                                metaData.tdAttr = 'data-qtip="' + value + '"';
                                                                                return value;
                                                                            },
                                                                            id: 'metric_service_column',
                                                                            dataIndex: 'service_description',
                                                                            text: Ext.locale.translate('Service'),
                                                                            flex: 1
                                                                        },
                                                                        {
                                                                            xtype: 'gridcolumn',
                                                                            renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                                                                                metaData.tdAttr = 'data-qtip="' + value + '"';
                                                                                return value;
                                                                            },
                                                                            dataIndex: 'metric',
                                                                            text: Ext.locale.translate('Metric'),
                                                                            flex: 1
                                                                        },
                                                                        {
                                                                            xtype: 'gridcolumn',
                                                                            dataIndex: 'unit',
                                                                            text: Ext.locale.translate('Unit'),
                                                                            flex: 1
                                                                        }
                                                                    ],
                                                                    viewConfig: {
                                                                        id: 'SelectedElementsGridView1',
                                                                        deferEmptyText: false,
                                                                        emptyText: Ext.locale.translate('There are no metric available')
                                                                    },
                                                                    selModel: Ext.create('Ext.selection.CheckboxModel', {
                                                                        ignoreRightMouseSelection: true,
                                                                        checkOnly: true,
                                                                        showHeaderCheckbox: true
                                                                    }),
                                                                    dockedItems: [
                                                                        {
                                                                            xtype: 'toolbar',
                                                                            dock: 'bottom',
                                                                            cls: 'silver-grey-bg',
                                                                            items: [
                                                                                {
                                                                                    xtype: 'label',
                                                                                    id: 'metrics_counter',
                                                                                    text: Ext.locale.translate('There are no metrics selected yet')
                                                                                }
                                                                            ]
                                                                        },
                                                                        {
                                                                            xtype: 'container',
                                                                            dock: 'bottom',
                                                                            cls: 'red-alert-bg',
                                                                            hidden: true,
                                                                            id: 'metric_unit_alert_container',
                                                                            padding: 10,
                                                                            width: 100,
                                                                            items: [
                                                                                {
                                                                                    xtype: 'label',
                                                                                    id: 'metrics_unit_alert',
                                                                                    margin: '-30 0 0 0',
                                                                                    text: Ext.locale.translate('You reached the limit of units that can be selected')
                                                                                }
                                                                            ]
                                                                        }
                                                                    ],
                                                                    plugins: [
                                                                        Ext.create('Ext.grid.plugin.BufferedRenderer', {

                                                                        })
                                                                    ]
                                                                }
                                                            ],
                                                            dockedItems: [
                                                                {
                                                                    xtype: 'toolbar',
                                                                    flex: 1,
                                                                    margins: '0',
                                                                    dock: 'bottom',
                                                                    padding: '7 6 10',
                                                                    items: [
                                                                        {
                                                                            xtype: 'tbspacer',
                                                                            flex: 1
                                                                        },
                                                                        {
                                                                            xtype: 'checkboxfield',
                                                                            id: 'aggregate_by_metric',
                                                                            name: 'showThresholdCp',
                                                                            boxLabel: Ext.locale.translate('Group by metric'),
                                                                            inputValue: '1',
                                                                            uncheckedValue: '0'
                                                                        }
                                                                    ]
                                                                }
                                                            ]
                                                        },
                                                        {
                                                            xtype: 'panel',
                                                            region: 'south',
                                                            cls: 'oppanel',
                                                            id: 'output_wrapper',
                                                            bodyPadding: '0 14',
                                                            placeholder: 'Default',
                                                            title: '<span class="header-num">3</span> '+Ext.locale.translate('Define Output')+'',
                                                            layout: {
                                                                type: 'vbox',
                                                                align: 'stretch'
                                                            },
                                                            items: [
                                                                {
                                                                    xtype: 'container',
                                                                    layout: {
                                                                        type: 'hbox',
                                                                        align: 'bottom'
                                                                    },
                                                                    items: [
                                                                        {
                                                                            xtype: 'toolbar',
                                                                            margin: '5 0 0 0',
                                                                            padding: 0,
                                                                            items: [
                                                                                {
                                                                                    xtype: 'splitbutton',
                                                                                    allowDepress: false,
                                                                                    text: Ext.locale.translate('Advanced options'),
                                                                                    textAlign: 'left',
                                                                                    menu: {
                                                                                        xtype: 'menu',
                                                                                        id: 'advanced_options',
                                                                                        allowOtherMenus: true,
                                                                                        items: [
                                                                                            {
                                                                                                xtype: 'menucheckitem',
                                                                                                id: 'advanced_thresholds',
                                                                                                text: Ext.locale.translate('Show thresholds')
                                                                                            },
                                                                                            {
                                                                                                xtype: 'menucheckitem',
                                                                                                id: 'advanced_autoscale',
                                                                                                text: Ext.locale.translate('Auto scale')
                                                                                            },
                                                                                            {
                                                                                                xtype: 'menucheckitem',
                                                                                                id: 'advanced_95pc',
                                                                                                text: '95%'
                                                                                            },
                                                                                            {
                                                                                                xtype: 'menucheckitem',
                                                                                                id: 'advanced_graphicsinpc',
                                                                                                text: Ext.locale.translate('Graphics in %')
                                                                                            },
                                                                                            {
                                                                                                xtype: 'menucheckitem',
                                                                                                id: 'advanced_trendlines',
                                                                                                text: Ext.locale.translate('Trend lines')
                                                                                            },
                                                                                            {
                                                                                                xtype: 'menucheckitem',
                                                                                                hidden: true,
                                                                                                id: 'advanced_trendlines_showalarms',
                                                                                                margin: '0 0 0 25',
                                                                                                text: Ext.locale.translate('Show alarms')
                                                                                            },
                                                                                            {
                                                                                                xtype: 'menucheckitem',
                                                                                                id: 'advanced_futuretrend',
                                                                                                text: Ext.locale.translate('Future trend')
                                                                                            },
                                                                                            {
                                                                                                xtype: 'numberfield',
                                                                                                hidden: true,
                                                                                                id: 'advanced_futuretrend_months',
                                                                                                margin: '0 0 0 27',
                                                                                                maxWidth: 150,
                                                                                                width: 100,
                                                                                                fieldLabel: Ext.locale.translate('Months'),
                                                                                                labelWidth: 55,
                                                                                                name: 'monthsCounter',
                                                                                                value: 1,
                                                                                                maxValue: 24,
                                                                                                minValue: 1
                                                                                            },
                                                                                            {
                                                                                                xtype: 'menucheckitem',
                                                                                                id: 'advanced_absoluteminmax',
                                                                                                text: Ext.locale.translate('Absolute min/max')
                                                                                            }
                                                                                        ]
                                                                                    }
                                                                                }
                                                                            ]
                                                                        },
                                                                        {
                                                                            xtype: 'container',
                                                                            flex: 1
                                                                        },
                                                                        {
                                                                            xtype: 'combobox',
                                                                            hidden: true,
                                                                            id: 'output_type_old',
                                                                            margin: '5 10 0 0',
                                                                            width: 205,
                                                                            fieldLabel: Ext.locale.translate('Output'),
                                                                            hideLabel: true,
                                                                            name: 'sendByEmail',
                                                                            value: '0',
                                                                            emptyText: Ext.locale.translate('Select an output type...'),
                                                                            editable: false,
                                                                            displayField: 'name',
                                                                            forceSelection: true,
                                                                            queryMode: 'local',
                                                                            store: 'outputs_store',
                                                                            valueField: 'value'
                                                                        },
                                                                        {
                                                                            xtype: 'checkboxfield',
                                                                            id: 'output_type',
                                                                            margin: '5 10 0 0',
                                                                            fieldLabel: '',
                                                                            boxLabel: Ext.locale.translate('Send report by e-mail')
                                                                        },
                                                                        {
                                                                            xtype: 'button',
                                                                            disabled: true,
                                                                            id: 'generate_btn',
                                                                            margin: '5 0 0 0',
                                                                            text: Ext.locale.translate('Generate report')
                                                                        }
                                                                    ]
                                                                },
                                                                {
                                                                    xtype: 'gridpanel',
                                                                    flex: 1,
                                                                    cls: 'opsubpanel',
                                                                    hidden: true,
                                                                    id: 'email_container',
                                                                    maxHeight: 450,
                                                                    autoScroll: true,
                                                                    animCollapse: false,
                                                                    collapseFirst: false,
                                                                    collapsed: false,
                                                                    collapsible: false,
                                                                    title: Ext.locale.translate('Send by e-mail for'),
                                                                    titleCollapse: true,
                                                                    forceFit: true,
                                                                    scroll: 'vertical',
                                                                    store: 'contacts',
                                                                    columns: [
                                                                        {
                                                                            xtype: 'gridcolumn',
                                                                            dataIndex: 'contact_name',
                                                                            text: Ext.locale.translate('Contact name'),
                                                                            flex: 1
                                                                        },
                                                                        {
                                                                            xtype: 'gridcolumn',
                                                                            dataIndex: 'email',
                                                                            text: Ext.locale.translate('Email'),
                                                                            flex: 1
                                                                        },
                                                                        {
                                                                            xtype: 'gridcolumn',
                                                                            dataIndex: 'alias',
                                                                            text: Ext.locale.translate('Description'),
                                                                            flex: 3
                                                                        }
                                                                    ],
                                                                    viewConfig: {
                                                                        id: 'EmailGridView'
                                                                    },
                                                                    selModel: Ext.create('Ext.selection.CheckboxModel', {
                                                                        allowDeselect: true,
                                                                        toggleOnClick: false,
                                                                        showHeaderCheckbox: true
                                                                    })
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    id: 'advanced_output',
                                                                    layout: {
                                                                        type: 'hbox',
                                                                        align: 'stretch'
                                                                    },
                                                                    items: [
                                                                        {
                                                                            xtype: 'form',
                                                                            cls: 'opsubpanel',
                                                                            hidden: true,
                                                                            id: 'advanced_options1',
                                                                            margin: '0 20 0 0',
                                                                            width: 175,
                                                                            collapsed: false,
                                                                            collapsible: false,
                                                                            header: false,
                                                                            title: Ext.locale.translate('Advanced options'),
                                                                            titleCollapse: true,
                                                                            items: [
                                                                                {
                                                                                    xtype: 'checkboxfield',
                                                                                    anchor: '100%',
                                                                                    id: 'advanced_thresholds1',
                                                                                    name: 'showThresholdCp',
                                                                                    boxLabel: Ext.locale.translate('Show thresholds'),
                                                                                    inputValue: '1',
                                                                                    uncheckedValue: '0'
                                                                                },
                                                                                {
                                                                                    xtype: 'checkboxfield',
                                                                                    anchor: '100%',
                                                                                    id: 'advanced_autoscale1',
                                                                                    name: 'autoScale',
                                                                                    boxLabel: Ext.locale.translate('Auto scale'),
                                                                                    inputValue: '1',
                                                                                    uncheckedValue: '0'
                                                                                },
                                                                                {
                                                                                    xtype: 'checkboxfield',
                                                                                    anchor: '100%',
                                                                                    id: 'advanced_95pc1',
                                                                                    name: 'show95Percentil',
                                                                                    boxLabel: '95%',
                                                                                    inputValue: '1',
                                                                                    uncheckedValue: '0'
                                                                                },
                                                                                {
                                                                                    xtype: 'checkboxfield',
                                                                                    anchor: '100%',
                                                                                    id: 'advanced_graphicsinpc1',
                                                                                    name: 'percentGraphs',
                                                                                    boxLabel: Ext.locale.translate('Graphics in %'),
                                                                                    inputValue: '1',
                                                                                    uncheckedValue: '0'
                                                                                },
                                                                                {
                                                                                    xtype: 'checkboxfield',
                                                                                    anchor: '100%',
                                                                                    id: 'advanced_trendlines1',
                                                                                    name: 'baselineTrend',
                                                                                    boxLabel: Ext.locale.translate('Trend lines'),
                                                                                    inputValue: '1',
                                                                                    uncheckedValue: '0'
                                                                                },
                                                                                {
                                                                                    xtype: 'checkboxfield',
                                                                                    anchor: '100%',
                                                                                    hidden: true,
                                                                                    id: 'advanced_trendlines_showalarms1',
                                                                                    margin: '-5 0 5 20',
                                                                                    name: 'baselineTrendShowAlarms',
                                                                                    boxLabel: Ext.locale.translate('Show alarms'),
                                                                                    inputValue: '1',
                                                                                    uncheckedValue: '0'
                                                                                },
                                                                                {
                                                                                    xtype: 'checkboxfield',
                                                                                    anchor: '100%',
                                                                                    id: 'advanced_futuretrend1',
                                                                                    name: 'futureTrend',
                                                                                    boxLabel: Ext.locale.translate('Future trend'),
                                                                                    inputValue: '1',
                                                                                    uncheckedValue: '0'
                                                                                },
                                                                                {
                                                                                    xtype: 'numberfield',
                                                                                    anchor: '100%',
                                                                                    hidden: true,
                                                                                    id: 'advanced_futuretrend_months1',
                                                                                    margin: '-4 0 4 19',
                                                                                    maxWidth: 150,
                                                                                    width: 100,
                                                                                    fieldLabel: Ext.locale.translate('Months'),
                                                                                    labelWidth: 55,
                                                                                    name: 'monthsCounter',
                                                                                    value: 1,
                                                                                    maxValue: 24,
                                                                                    minValue: 1
                                                                                },
                                                                                {
                                                                                    xtype: 'checkboxfield',
                                                                                    anchor: '100%',
                                                                                    id: 'advanced_absoluteminmax1',
                                                                                    name: 'absoluteMinMax',
                                                                                    boxLabel: Ext.locale.translate('Absolute min/max'),
                                                                                    inputValue: '1',
                                                                                    uncheckedValue: '0'
                                                                                }
                                                                            ]
                                                                        }
                                                                    ]
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    id: 'third_step'
                                }
                            ]
                        },
                        {
                            xtype: 'panel',
                            id: 'graphic_card',
                            layout: 'card',
                            items: [
                                {
                                    xtype: 'overviewcontent'
                                },
                                {
                                    xtype: 'portalpanel',
                                    cls: 'grey-bg oppanel',
                                    id: 'detailed_tab',
                                    layout: 'card',
                                    bodyPadding: '15 5'
                                }
                            ]
                        },
                        {
                            xtype: 'panel',
                            id: 'custom_card',
                            layout: {
                                type: 'vbox',
                                align: 'stretch'
                            },
                            items: [
                                {
                                    xtype: 'component',
                                    flex: 1,
                                    autoEl: {
                                        tag: 'iframe'
                                    },
                                    hidden: true,
                                    id: 'pdfIframe'
                                },
                                {
                                    xtype: 'tabpanel',
                                    flex: 1,
                                    activeTab: 0,
                                    items: [
                                        {
                                            xtype: 'panel',
                                            id: 'custom_overview_tab',
                                            title: Ext.locale.translate('Overview'),
                                            layout: {
                                                type: 'vbox',
                                                align: 'stretch'
                                            },
                                            tabConfig: {
                                                xtype: 'tab',
                                                margin: '0 5 0 15'
                                            },
                                            items: [
                                                {
                                                    xtype: 'pdfpanel',
                                                    flex: 1,
                                                    id: 'custom_content'
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ],
                            dockedItems: [
                                {
                                    xtype: 'toolbar',
                                    flex: 1,
                                    dock: 'bottom',
                                    items: [
                                        {
                                            xtype: 'splitbutton',
                                            cls: '',
                                            id: 'export_bar1',
                                            text: 'Export to',
                                            menu: {
                                                xtype: 'menu',
                                                width: 120,
                                                items: [
                                                    {
                                                        xtype: 'menuitem',
                                                        id: 'export_xml_button1',
                                                        itemId: 'export_xml_button',
                                                        iconCls: 'fa fa-file-code-o icon-half-black',
                                                        text: 'Export to <strong>.xml</strong>'
                                                    },
                                                    {
                                                        xtype: 'menuitem',
                                                        id: 'export_pdf_button1',
                                                        itemId: 'export_pdf_button',
                                                        iconCls: 'fa fa-file-pdf-o icon-half-black',
                                                        text: 'Export to <strong>.pdf</strong>'
                                                    },
                                                    {
                                                        xtype: 'menuitem',
                                                        id: 'export_xls_button1',
                                                        itemId: 'export_xls_button',
                                                        iconCls: 'fa fa-file-code-o icon-half-black',
                                                        text: 'Export to <strong>.xls</strong>'
                                                    }
                                                ]
                                            }
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onCustomActionButtonsAfterRender: function(component, eOpts) {
        var el = parent.document.getElementById('userName');
        var contact_type_operator = '2';

        if (el) {
            component.setVisible(el.getAttribute('type') !== contact_type_operator);
        }
    }

});