/*
 * File: app/view/OverviewContent.js
 *
 * This file was generated by Sencha Architect version 4.2.4.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Reports.view.OverviewContent', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.overviewcontent',

    requires: [
        'Ext.form.Label',
        'Ext.grid.Panel',
        'Ext.grid.column.Number',
        'Ext.grid.View',
        'Ext.button.Split',
        'Ext.menu.Menu',
        'Ext.menu.Item',
        'Ext.toolbar.Spacer',
        'Ext.form.Panel',
        'Ext.form.field.ComboBox',
        'Ext.form.field.Display',
        'Ext.toolbar.Separator',
        'Ext.container.ButtonGroup',
        'Ext.toolbar.Paging',
        'Ext.grid.column.Date',
        'Ext.panel.Tool'
    ],

    cls: 'oppanel',
    id: 'overview_tab',
    bodyCls: 'white-bg',
    header: false,
    title: Ext.locale.translate('Overview'),

    layout: {
        type: 'hbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'container',
                    flex: 1,
                    cls: 'white-bg',
                    id: 'overview_container',
                    layout: 'card',
                    items: [
                        {
                            xtype: 'container',
                            id: 'nodata_content',
                            layout: {
                                type: 'hbox',
                                align: 'middle',
                                pack: 'center'
                            },
                            items: [
                                {
                                    xtype: 'label',
                                    text: Ext.locale.translate('No Data')
                                }
                            ]
                        },
                        {
                            xtype: 'gridpanel',
                            id: 'tabular_content',
                            header: false,
                            title: Ext.locale.translate('Tabular'),
                            store: 'tabular_store',
                            columns: [
                                {
                                    xtype: 'numbercolumn',
                                    id: 'tabular_content_column_index',
                                    width: 50,
                                    sortable: true,
                                    dataIndex: 'index',
                                    text: '',
                                    format: '0'
                                },
                                {
                                    xtype: 'gridcolumn',
                                    id: 'tabular_content_column_host',
                                    sortable: true,
                                    dataIndex: 'host',
                                    text: Ext.locale.translate('Host')
                                },
                                {
                                    xtype: 'gridcolumn',
                                    id: 'tabular_content_column_service',
                                    sortable: true,
                                    dataIndex: 'service',
                                    text: Ext.locale.translate('Service')
                                },
                                {
                                    xtype: 'gridcolumn',
                                    id: 'tabular_content_column_metric',
                                    sortable: true,
                                    dataIndex: 'metric',
                                    text: Ext.locale.translate('Metric'),
                                    flex: 1
                                },
                                {
                                    xtype: 'numbercolumn',
                                    renderer: function(val, cell) {
                                        //return Reports.getApplication().getController('DefaultController').onTabularContentColumnRenderSparkline(val,cell);
                                        return Reports.getApplication().getController('DefaultController').onTabularContentColumnRender(val,cell);
                                    },
                                    id: 'tabular_content_column_variation',
                                    maxWidth: 130,
                                    minWidth: 130,
                                    width: 130,
				    hidden: true,
				    hide: true,
				    disable: true,
                                    sortable: true,
                                    dataIndex: 'variation',
                                    text: Ext.locale.translate('Period variation')
                                },
                                {
                                    xtype: 'gridcolumn',
                                    text: Ext.locale.translate('Period metrics'),
                                    columns: [
                                        {
                                            xtype: 'numbercolumn',
                                            renderer: function(val, cell) {
                                                return Reports.getApplication().getController('DefaultController').onTabularContentColumnRender(val,cell);
                                            },
                                            id: 'tabular_content_column_min',
                                            width: 80,
                                            sortable: true,
                                            align: 'right',
                                            dataIndex: 'min',
                                            text: Ext.locale.translate('Min')
                                        },
                                        {
                                            xtype: 'numbercolumn',
                                            renderer: function(val, cell) {
                                                return Reports.getApplication().getController('DefaultController').onTabularContentColumnRender(val,cell);
                                            },
                                            id: 'tabular_content_column_max',
                                            width: 80,
                                            sortable: true,
                                            align: 'right',
                                            dataIndex: 'max',
                                            text: Ext.locale.translate('Max')
                                        },
                                        {
                                            xtype: 'numbercolumn',
                                            renderer: function(val, cell) {
                                                return Reports.getApplication().getController('DefaultController').onTabularContentColumnRender(val,cell);
                                            },
                                            id: 'tabular_content_column_avg',
                                            width: 80,
                                            sortable: true,
                                            align: 'right',
                                            dataIndex: 'avg',
                                            text: Ext.locale.translate('Average')
                                        }
                                    ]
                                },
                                {
                                    xtype: 'gridcolumn',
                                    text: Ext.locale.translate('Last check'),
                                    columns: [
                                        {
                                            xtype: 'numbercolumn',
                                            renderer: function(val, cell) {
                                                return Reports.getApplication().getController('DefaultController').onTabularContentColumnRender(val,cell);
                                            },
                                            id: 'tabular_content_column_limit_min',
                                            width: 80,
                                            sortable: true,
                                            align: 'right',
                                            dataIndex: 'limitMin',
                                            text: Ext.locale.translate('Min')
                                        },
                                        {
                                            xtype: 'numbercolumn',
                                            renderer: function(val, cell) {
                                                //return Reports.getApplication().getController('DefaultController').onTabularContentColumnRenderProgressbar(val,cell);
                                                return Reports.getApplication().getController('DefaultController').onTabularContentColumnRender(val,cell);
                                            },
                                            id: 'tabular_content_column_usage',
                                            width: 150,
                                            sortable: true,
                                            dataIndex: 'usage',
                                            text: Ext.locale.translate('Usage')
                                        },
                                        {
                                            xtype: 'numbercolumn',
                                            renderer: function(val, cell) {
                                                return Reports.getApplication().getController('DefaultController').onTabularContentColumnRender(val,cell);
                                            },
                                            id: 'tabular_content_column_limit_max',
                                            width: 80,
                                            sortable: true,
                                            align: 'right',
                                            dataIndex: 'limitMax',
                                            text: Ext.locale.translate('Max')
                                        }
                                    ]
                                }
                            ],
                            viewConfig: {
                                id: 'tabular_content_view'
                            },
                            dockedItems: [
                                {
                                    xtype: 'container',
                                    dock: 'bottom',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch'
                                    },
                                    items: [
                                        {
                                            xtype: 'toolbar',
                                            flex: 1,
                                            items: [
                                                {
                                                    xtype: 'splitbutton',
                                                    cls: '',
                                                    id: 'tabular_export_bar',
                                                    text: 'Export to',
                                                    menu: {
                                                        xtype: 'menu',
                                                        width: 120,
                                                        items: [
                                                            {
                                                                xtype: 'menuitem',
                                                                id: 'tabular_export_xml_button',
                                                                iconCls: 'fa fa-file-code-o icon-half-black',
                                                                text: 'Export to <strong>.xml</strong>'
                                                            },
                                                            {
                                                                xtype: 'menuitem',
                                                                id: 'tabular_export_pdf_button',
                                                                iconCls: 'fa fa-file-pdf-o icon-half-black',
                                                                text: 'Export to <strong>.pdf</strong>'
                                                            },
                                                            {
                                                                xtype: 'menuitem',
                                                                hidden: true,
                                                                id: 'tabular_export_xls_button',
                                                                iconCls: 'fa fa-file-code-o icon-half-black',
                                                                text: 'Export to <strong>.xls</strong>'
                                                            }
                                                        ]
                                                    }
                                                },
                                                {
                                                    xtype: 'tbspacer',
                                                    flex: 1
                                                },
                                                {
                                                    xtype: 'form',
                                                    id: 'graphic_report_settings1',
                                                    margin: 0,
                                                    layout: {
                                                        type: 'hbox',
                                                        align: 'stretch',
                                                        pack: 'end'
                                                    },
                                                    items: [
                                                        {
                                                            xtype: 'combobox',
                                                            id: 'tabular_period_field_report',
                                                            margin: '0 8 0 0',
                                                            width: 190,
                                                            fieldLabel: '',
                                                            labelAlign: 'top',
                                                            labelWidth: 64,
                                                            name: 'reportPeriod',
                                                            value: 'last24hours',
                                                            emptyText: Ext.locale.translate('Select period...'),
                                                            editable: false,
                                                            displayField: 'name',
                                                            forceSelection: true,
                                                            queryMode: 'local',
                                                            store: 'timeperiods',
                                                            valueField: 'value'
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    dock: 'top',
                                    width: 100,
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch'
                                    },
                                    items: [
                                        {
                                            xtype: 'form',
                                            flex: 1,
                                            id: 'tabular_period_container',
                                            padding: 0,
                                            width: 100,
                                            layout: {
                                                type: 'hbox',
                                                align: 'stretch',
                                                pack: 'end'
                                            },
                                            items: [
                                                {
                                                    xtype: 'displayfield',
                                                    cls: 'display-multiline bold',
                                                    height: 24,
                                                    id: 'tabular_current_period',
                                                    margin: '0 15 0 0',
                                                    maxHeight: 24,
                                                    fieldLabel: Ext.locale.translate('Period'),
                                                    labelWidth: 64,
                                                    name: 'current_period'
                                                },
                                                {
                                                    xtype: 'displayfield',
                                                    cls: 'display-multiline bold',
                                                    height: 24,
                                                    id: 'tabular_current_duration',
                                                    margin: '0 15 0 10',
                                                    fieldLabel: Ext.locale.translate('Duration'),
                                                    labelWidth: 64,
                                                    name: 'current_duration'
                                                },
                                                {
                                                    xtype: 'displayfield',
                                                    cls: 'display-multiline bold',
                                                    height: 24,
                                                    id: 'tabular_current_timecut',
                                                    margin: '0 15 0 10',
                                                    fieldLabel: Ext.locale.translate('Timecut'),
                                                    labelWidth: 64,
                                                    name: 'timeCutName'
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    dock: 'top',
                                    width: 100
                                }
                            ]
                        },
                        {
                            xtype: 'panel',
                            baseCls: 'white-bg',
                            cls: 'opsubpanel white-bg',
                            id: 'overview_content',
                            defaults: {
                                split: false
                            },
                            layout: 'border',
                            bodyBorder: false,
                            bodyCls: 'white-bg',
                            bodyPadding: 0,
                            dockedItems: [
                                {
                                    xtype: 'toolbar',
                                    flex: 1,
                                    dock: 'top',
                                    margin: '0 0 5 0',
                                    padding: '2 0 2 7',
                                    items: [
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            id: 'select_metric_wrapper',
                                            margin: '2 8 5 3',
                                            padding: 0,
                                            layout: 'card',
                                            items: [
                                                {
                                                    xtype: 'combobox',
                                                    hideMode: 'visibility',
                                                    id: 'cmb_selected_reports',
                                                    width: 350,
                                                    fieldLabel: '',
                                                    displayField: 'name',
                                                    queryMode: 'local',
                                                    store: 'selectedItems',
                                                    valueField: 'value'
                                                },
                                                {
                                                    xtype: 'displayfield',
                                                    cls: 'bold',
                                                    height: 14,
                                                    id: 'metric_aggregated_label',
                                                    margin: '-36 0 0 7',
                                                    fieldLabel: '',
                                                    value: Ext.locale.translate('Metric Aggregated')
                                                }
                                            ]
                                        },
                                        {
                                            xtype: 'form',
                                            id: 'graphic_report_settings',
                                            bodyPadding: 10,
                                            layout: {
                                                type: 'hbox',
                                                align: 'stretch',
                                                pack: 'end'
                                            },
                                            items: [
                                                {
                                                    xtype: 'combobox',
                                                    margins: '0 10 0 0',
                                                    id: 'timecut_report',
                                                    padding: 0,
                                                    width: 160,
                                                    fieldLabel: '',
                                                    labelAlign: 'top',
                                                    labelWidth: 64,
                                                    name: 'timeCutId',
                                                    emptyText: Ext.locale.translate('Select a timecut...'),
                                                    editable: false,
                                                    displayField: 'name',
                                                    forceSelection: true,
                                                    queryMode: 'local',
                                                    store: 'timecuts',
                                                    valueField: 'value'
                                                },
                                                {
                                                    xtype: 'combobox',
                                                    id: 'period_field_report',
                                                    margin: '0 8 0 0',
                                                    width: 159,
                                                    fieldLabel: '',
                                                    labelAlign: 'top',
                                                    labelWidth: 64,
                                                    name: 'reportPeriod',
                                                    value: 'last24hours',
                                                    emptyText: Ext.locale.translate('Select period...'),
                                                    editable: false,
                                                    displayField: 'name',
                                                    forceSelection: true,
                                                    queryMode: 'local',
                                                    store: 'timeperiods',
                                                    valueField: 'value'
                                                }
                                            ]
                                        },
                                        {
                                            xtype: 'tbseparator',
                                            margin: '0 1 0 0'
                                        },
                                        {
                                            xtype: 'toolbar',
                                            height: 38,
                                            margin: '0 1 0 0',
                                            padding: 0,
                                            items: [
                                                {
                                                    xtype: 'buttongroup',
                                                    border: false,
                                                    frame: false,
                                                    id: 'legend_button_group',
                                                    margin: '0 0 -10',
                                                    frameHeader: false,
                                                    header: false,
                                                    columns: 3,
                                                    items: [
                                                        {
                                                            xtype: 'button',
                                                            componentCls: 'abtn-reset',
                                                            frame: false,
                                                            height: 20,
                                                            hidden: true,
                                                            id: 'legend_panel_button_check',
                                                            enableToggle: true,
                                                            iconCls: 'fa fa-check-square icon-half-black',
                                                            pressed: true,
                                                            text: Ext.locale.translate('Metrics')
                                                        },
                                                        {
                                                            xtype: 'button',
                                                            componentCls: 'abtn-reset',
                                                            frame: false,
                                                            height: 20,
                                                            id: 'legend_panel_button_thresholds',
                                                            enableToggle: true,
                                                            iconCls: 'fa fa-line-chart icon-half-black',
                                                            text: Ext.locale.translate('Thresholds')
                                                        },
                                                        {
                                                            xtype: 'button',
                                                            componentCls: 'abtn-reset',
                                                            frame: false,
                                                            height: 20,
                                                            id: 'legend_panel_button_autoscale',
                                                            enableToggle: true,
                                                            iconCls: 'fa fa-bar-chart icon-half-black',
                                                            text: Ext.locale.translate('Autoscale')
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ],
                                    listeners: {
                                        beforerender: {
                                            fn: me.onToolbarBeforeRender,
                                            scope: me
                                        }
                                    }
                                },
                                {
                                    xtype: 'container',
                                    flex: 1,
                                    dock: 'bottom',
                                    id: 'overview_footer',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch'
                                    },
                                    items: [
                                        {
                                            xtype: 'toolbar',
                                            flex: 1,
                                            items: [
                                                {
                                                    xtype: 'splitbutton',
                                                    cls: '',
                                                    id: 'export_bar',
                                                    text: 'Export to',
                                                    menu: {
                                                        xtype: 'menu',
                                                        width: 120,
                                                        items: [
                                                            {
                                                                xtype: 'menuitem',
                                                                id: 'export_xml_button',
                                                                iconCls: 'fa fa-file-code-o icon-half-black',
                                                                text: 'Export to <strong>.xml</strong>'
                                                            },
                                                            {
                                                                xtype: 'menuitem',
                                                                id: 'export_pdf_button',
                                                                iconCls: 'fa fa-file-pdf-o icon-half-black',
                                                                text: 'Export to <strong>.pdf</strong>'
                                                            },
                                                            {
                                                                xtype: 'menuitem',
                                                                id: 'export_png_button',
                                                                iconCls: 'fa fa-file-image-o icon-half-black',
                                                                text: 'Export to <strong>.png</strong>'
                                                            },
                                                            {
                                                                xtype: 'menuitem',
                                                                id: 'export_xls_button',
                                                                iconCls: 'fa fa-file-code-o icon-half-black',
                                                                text: 'Export to <strong>.xls</strong>'
                                                            }
                                                        ]
                                                    }
                                                }
                                            ]
                                        },
                                        {
                                            xtype: 'pagingtoolbar',
                                            flex: 1,
                                            id: 'overview_paging',
                                            padding: 8,
                                            prependButtons: true,
                                            store: 'service_paging',
                                            layout: {
                                                type: 'hbox',
                                                pack: 'end'
                                            }
                                        }
                                    ]
                                }
                            ],
                            items: [
                                {
                                    xtype: 'container',
                                    flex: 1,
                                    floatable: false,
                                    floating: true,
                                    hidden: true,
                                    id: 'overview_nodata_content',
                                    shadow: false,
                                    layout: {
                                        type: 'hbox',
                                        align: 'middle',
                                        pack: 'center'
                                    },
                                    items: [
                                        {
                                            xtype: 'label',
                                            cls: 'nodata',
                                            minWidth: 100,
                                            text: Ext.locale.translate('No Data')
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    flex: 1,
                                    region: 'center',
                                    id: 'wrap_graphic_container',
                                    padding: '4 0 0 0',
                                    layout: {
                                        type: 'vbox',
                                        align: 'stretch'
                                    },
                                    items: [
                                        {
                                            xtype: 'form',
                                            cls: 'opsubpanel',
                                            id: 'info_form_container',
                                            header: false,
                                            headerOverCls: 'x-tab-default',
                                            title: 'Dados do relatório',
                                            layout: {
                                                type: 'hbox',
                                                padding: '0 3 0 8'
                                            },
                                            items: [
                                                {
                                                    xtype: 'container',
                                                    flex: 1,
                                                    id: 'info_container',
                                                    layout: {
                                                        type: 'vbox',
                                                        align: 'stretch'
                                                    },
                                                    items: [
                                                        {
                                                            xtype: 'container',
                                                            flex: 1,
                                                            layout: {
                                                                type: 'vbox',
                                                                align: 'stretch'
                                                            },
                                                            items: [
                                                                {
                                                                    xtype: 'container',
                                                                    hidden: true,
                                                                    id: 'overview_names_container',
                                                                    margin: '10 0 0 30',
                                                                    layout: {
                                                                        type: 'vbox',
                                                                        align: 'stretch'
                                                                    },
                                                                    items: [
                                                                        {
                                                                            xtype: 'displayfield',
                                                                            cls: 'display-multiline bold',
                                                                            id: 'overview_host_name',
                                                                            margin: '0 15 0 0',
                                                                            fieldLabel: Ext.locale.translate('Host'),
                                                                            labelAlign: 'right',
                                                                            labelWidth: 60,
                                                                            name: 'host_name',
                                                                            value: ''
                                                                        },
                                                                        {
                                                                            xtype: 'displayfield',
                                                                            flex: 1,
                                                                            cls: 'display-multiline bold',
                                                                            height: 24,
                                                                            id: 'overview_service_description',
                                                                            margin: '0 0 10',
                                                                            maxHeight: 24,
                                                                            fieldLabel: Ext.locale.translate('Service'),
                                                                            labelAlign: 'right',
                                                                            labelWidth: 60,
                                                                            name: 'service_description',
                                                                            value: '',
                                                                            fieldStyle: 'font-size: 18px;'
                                                                        }
                                                                    ]
                                                                },
                                                                {
                                                                    xtype: 'form',
                                                                    flex: 1,
                                                                    id: 'overview_period_container',
                                                                    padding: 0,
                                                                    layout: {
                                                                        type: 'hbox',
                                                                        align: 'stretch'
                                                                    },
                                                                    items: [
                                                                        {
                                                                            xtype: 'container',
                                                                            flex: 1
                                                                        },
                                                                        {
                                                                            xtype: 'displayfield',
                                                                            cls: 'display-multiline bold',
                                                                            height: 24,
                                                                            id: 'overview_current_period',
                                                                            margin: '0 15 0 0',
                                                                            maxHeight: 24,
                                                                            fieldLabel: Ext.locale.translate('Period'),
                                                                            labelWidth: 64,
                                                                            name: 'current_period'
                                                                        },
                                                                        {
                                                                            xtype: 'displayfield',
                                                                            cls: 'display-multiline bold',
                                                                            height: 24,
                                                                            id: 'overview_current_duration',
                                                                            margin: '0 15 0 10',
                                                                            fieldLabel: Ext.locale.translate('Duration'),
                                                                            labelWidth: 68,
                                                                            name: 'current_duration'
                                                                        }
                                                                    ]
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        },
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            id: 'graphic_container',
                                            padding: 0
                                        },
                                        {
                                            xtype: 'container',
                                            layout: {
                                                type: 'hbox',
                                                align: 'middle',
                                                pack: 'center'
                                            },
                                            items: [
                                                {
                                                    xtype: 'container',
                                                    cls: 'realtime-btn--play-control',
                                                    hidden: true,
                                                    id: 'realtime_container',
                                                    margin: '0 15 0 0',
                                                    padding: '',
                                                    items: [
                                                        {
                                                            xtype: 'button',
                                                            baseCls: 'x-container',
                                                            id: 'play_pause_realtime',
                                                            margin: '5 0 0 0',
                                                            padding: 10,
                                                            style: '{font-size: 18px; color: #333; margin-top: 2px; display: block; background: #EEE; cursor: pointer;}',
                                                            iconCls: 'fa fa-pause',
                                                            text: '',
                                                            listeners: {
                                                                render: {
                                                                    fn: me.onPlay_pause_realtimeRender,
                                                                    scope: me
                                                                }
                                                            }
                                                        }
                                                    ]
                                                },
                                                {
                                                    xtype: 'container',
                                                    flex: 1,
                                                    hidden: true,
                                                    id: 'options_container1',
                                                    margin: '',
                                                    items: [
                                                        {
                                                            xtype: 'form',
                                                            id: 'realtime_period_container',
                                                            padding: 0,
                                                            layout: {
                                                                type: 'hbox',
                                                                align: 'stretch'
                                                            },
                                                            items: [
                                                                {
                                                                    xtype: 'displayfield',
                                                                    flex: 1,
                                                                    id: 'realtime_current_period',
                                                                    fieldLabel: Ext.locale.translate('Period'),
                                                                    labelWidth: 64,
                                                                    name: 'current_period'
                                                                },
                                                                {
                                                                    xtype: 'displayfield',
                                                                    cls: 'display-multiline',
                                                                    hidden: true,
                                                                    id: 'realtime_current_duration',
                                                                    margin: '0 15 0 0',
                                                                    fieldLabel: Ext.locale.translate('Duration'),
                                                                    labelWidth: 64,
                                                                    name: 'current_duration'
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'gridpanel',
                                    floatable: false,
                                    region: 'east',
                                    cls: 'opsubpanel',
                                    id: 'legend_grid',
                                    width: 320,
                                    autoScroll: true,
                                    bodyBorder: false,
                                    collapseDirection: 'left',
                                    collapsed: false,
                                    collapsible: true,
                                    frameHeader: false,
                                    title: Ext.locale.translate('Legend'),
                                    titleCollapse: false,
                                    disableSelection: true,
                                    enableLocking: true,
                                    forceFit: true,
                                    scroll: 'vertical',
                                    store: 'metric_store',
                                    columns: [
                                        {
                                            xtype: 'gridcolumn',
                                            renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {

                                                var id = Ext.id();
                                                Ext.defer(function () {
                                                    var componentNotExists = (! Ext.get(id));
                                                    if (componentNotExists) return;

                                                    Ext.widget('button', {
                                                        renderTo: id,
                                                        width: 15,
                                                        height: 15,
                                                        componentCls: 'btn-reset',
                                                        frame: false,
                                                        iconCls: 'fa fa-check',
                                                        cls: 'legend-btn',
                                                        enableToggle: true,
                                                        style: {
                                                            background: record.data.color,
                                                            color: Op.Reports.Utils.shadeBlend(-0.4,record.data.color)
                                                        },
                                                        tooltip: (Ext.app.Config.realtimeMode) ? Ext.locale.translate('Metric') : Ext.locale.translate('Toggle metric') ,
                                                        toggleHandler: function (button,state) {
                                                            var graphic_container = Ext.getCmp('graphic_container');
                                                            if (graphic_container.chart) {
                                                                var chart = graphic_container.chart;
                                                                var graph = chart.getGraphByValueField(record.get('metric'));

                                                                console.time('Toogle button id: ' + this.id);

                                                                if (graph) {
                                                                    if (graph.hidden) {
                                                                        chart.chart.showGraph(graph);
                                                                        this.toggle(false);
                                                                        this.setIconCls('fa fa-check');
                                                                        this.getEl().setStyle('color',Op.Reports.Utils.shadeBlend(-0.4,record.get('color')));
                                                                    } else {
                                                                        chart.chart.hideGraph(graph);
                                                                        this.toggle(true);
                                                                        this.setIconCls('fa fa-remove');
                                                                        this.getEl().setStyle('color','gray');
                                                                    }

                                                                    var percentilTmp = chart.percentilGuide;
                                                                    chart.setPercentilGuide(false);
                                                                    chart.removeGuides();
                                                                    chart.setPercentilGuide(percentilTmp);
                                                                    chart.addGuides();
                                                                }
                                                                console.timeEnd('Toogle button id: ' + this.id);
                                                            }
                                                        }
                                                    });

                                                }, 50);

                                                return Ext.String.format('<div id="{0}"></div>', id);
                                            },
                                            componentCls: '',
                                            draggable: false,
                                            id: 'legend_grid_column_action',
                                            width: 38,
                                            resizable: false,
                                            hideable: false,
                                            menuDisabled: true,
                                            listeners: {
                                                render: {
                                                    fn: me.onLegend_grid_column_actionRender,
                                                    scope: me
                                                }
                                            }
                                        },
                                        {
                                            xtype: 'gridcolumn',
                                            renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                                                metaData.tdAttr = 'data-qtip="' + value + '"';
                                                return value;
                                            },
                                            id: 'legend_grid_column_metric',
                                            minWidth: 282,
                                            sortable: true,
                                            dataIndex: 'metric_name',
                                            lockable: true,
                                            text: Ext.locale.translate('Metric'),
                                            tooltip: Ext.locale.translate('Metric'),
                                            flex: 1
                                        },
                                        {
                                            xtype: 'gridcolumn',
                                            renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                                                metaData.tdAttr = 'data-qtip="' + value + '"';
                                                return value;
                                            },
                                            hidden: true,
                                            hideMode: 'visibility',
                                            id: 'legend_grid_column_host',
                                            minWidth: 94,
                                            sortable: true,
                                            dataIndex: 'host',
                                            lockable: true,
                                            text: Ext.locale.translate('Host'),
                                            tooltip: Ext.locale.translate('Host'),
                                            flex: 1
                                        },
                                        {
                                            xtype: 'gridcolumn',
                                            renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                                                metaData.tdAttr = 'data-qtip="' + value + '"';
                                                return value;
                                            },
                                            hidden: true,
                                            hideMode: 'visibility',
                                            id: 'legend_grid_column_service',
                                            minWidth: 94,
                                            sortable: true,
                                            dataIndex: 'service',
                                            lockable: true,
                                            text: Ext.locale.translate('Service'),
                                            tooltip: Ext.locale.translate('Service'),
                                            flex: 1
                                        },
                                        {
                                            xtype: 'numbercolumn',
                                            id: 'legend_grid_column_min',
                                            width: 70,
                                            sortable: true,
                                            align: 'right',
                                            dataIndex: 'min',
                                            lockable: true,
                                            text: Ext.locale.translate('Min'),
                                            tooltip: Ext.locale.translate('Minimum'),
                                            listeners: {
                                                boxready: {
                                                    fn: me.onLegend_grid_column_minBoxReady,
                                                    scope: me
                                                }
                                            }
                                        },
                                        {
                                            xtype: 'numbercolumn',
                                            id: 'legend_grid_column_max',
                                            width: 70,
                                            align: 'right',
                                            dataIndex: 'max',
                                            text: Ext.locale.translate('Max'),
                                            tooltip: Ext.locale.translate('Maximum'),
                                            listeners: {
                                                boxready: {
                                                    fn: me.onLegend_grid_column_maxBoxReady,
                                                    scope: me
                                                }
                                            }
                                        },
                                        {
                                            xtype: 'numbercolumn',
                                            id: 'legend_grid_column_avg',
                                            width: 70,
                                            align: 'right',
                                            dataIndex: 'avg',
                                            text: Ext.locale.translate('Avg'),
                                            tooltip: Ext.locale.translate('Average'),
                                            listeners: {
                                                boxready: {
                                                    fn: me.onLegend_grid_column_avgBoxReady,
                                                    scope: me
                                                }
                                            }
                                        },
                                        {
                                            xtype: 'numbercolumn',
                                            id: 'legend_grid_column_perc95',
                                            width: 70,
                                            align: 'right',
                                            dataIndex: 'perc95',
                                            text: Ext.locale.translate('Perc95'),
                                            tooltip: Ext.locale.translate('Percentage'),
                                            listeners: {
                                                boxready: {
                                                    fn: me.onLegend_grid_column_perc95BoxReady,
                                                    scope: me
                                                }
                                            }
                                        },
                                        {
                                            xtype: 'numbercolumn',
                                            id: 'legend_grid_column_last',
                                            width: 70,
                                            align: 'right',
                                            dataIndex: 'last',
                                            text: Ext.locale.translate('Last'),
                                            tooltip: Ext.locale.translate('Last'),
                                            listeners: {
                                                boxready: {
                                                    fn: me.onLegend_grid_column_lastBoxReady,
                                                    scope: me
                                                }
                                            }
                                        },
                                        {
                                            xtype: 'datecolumn',
                                            hidden: true,
                                            id: 'legend_grid_column_futuretrend',
                                            dataIndex: 'end_date',
                                            text: Ext.locale.translate('End date'),
                                            tooltip: Ext.locale.translate('End date'),
                                            format: 'd-m-Y',
                                            listeners: {
                                                boxready: {
                                                    fn: me.onLegend_grid_column_futuretrendBoxReady,
                                                    scope: me
                                                }
                                            }
                                        }
                                    ],
                                    viewConfig: {
                                        enableTextSelection: true
                                    },
                                    tools: [
                                        {
                                            xtype: 'tool',
                                            handler: function(event, toolEl, owner, tool) {
                                                var legend_grid = Ext.getCmp('legend_grid');
                                                legend_grid.setWidth(700);
                                                Ext.getCmp('legends_expand').hide();
                                                Ext.getCmp('legends_minimize').show();
                                            },
                                            id: 'legends_expand',
                                            type: 'maximize'
                                        },
                                        {
                                            xtype: 'tool',
                                            handler: function(event, toolEl, owner, tool) {
                                                var legend_grid = Ext.getCmp('legend_grid');
                                                legend_grid.setWidth(320);
                                                Ext.getCmp('legends_expand').show();
                                                Ext.getCmp('legends_minimize').hide();
                                            },
                                            id: 'legends_minimize',
                                            type: 'restore'
                                        }
                                    ],
                                    listeners: {
                                        afterrender: {
                                            fn: me.onLegend_gridAfterRender,
                                            scope: me
                                        }
                                    },
                                    dockedItems: [
                                        {
                                            xtype: 'toolbar',
                                            dock: 'top',
                                            height: 16,
                                            id: 'height_space_legend'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onToolbarBeforeRender: function(component, eOpts) {
        return (Ext.app.Config.realtimeMode === false);
    },

    onPlay_pause_realtimeRender: function(component, eOpts) {
        Ext.create('Ext.tip.ToolTip', {
            target: component.el,
            trackMouse: true,
            renderTo: Ext.getBody(),
            html: "Play / Stop"
        });
    },

    onLegend_grid_column_actionRender: function(component, eOpts) {
        var header_target = Ext.get('legend_grid_column_action-titleEl');

        Ext.widget('button', {
            renderTo: header_target,
            width: 15,
            height: 15,
            pressed: true,
            componentCls: 'btn-reset-all',
            frame: false,
            iconCls: 'fa fa-check',
            enableToggle: true,
            style: {
                background: '#666666',
                color: '#ffffff'
            },
            tooltip: Ext.locale.translate('Toggle metrics'),
            toggleHandler: function (button,state) {

                Ext.getBody().mask('Please wait...');

                console.time('toggle');

                setTimeout(function(){ // It is necessary for legend toggle does not start first than mask load
                    var legend_buttons = Ext.query('.legend-btn');

                    Ext.each(legend_buttons, function (legend_button) {
                        Ext.getCmp(legend_button.id).toggle(!state);
                    });

                    if (state) {
                        button.setIconCls('fa fa-check');
                        button.getEl().setStyle('color','#ffffff');
                    } else {
                        button.setIconCls('fa fa-remove');
                        button.getEl().setStyle('color','gray');
                    }


                    console.timeEnd('toggle');
                    Ext.getBody().unmask();
                }, 2);

            }
        });
    },

    onLegend_grid_column_minBoxReady: function(component, width, height, eOpts) {
        var cmp = Ext.getCmp('advanced_futuretrend');
        if (cmp && cmp.checked) {
            component.hide();
        } else {
            component.show();
        }
    },

    onLegend_grid_column_maxBoxReady: function(component, width, height, eOpts) {
        var cmp = Ext.getCmp('advanced_futuretrend');
        if (cmp && cmp.checked) {
            component.hide();
        } else {
            component.show();
        }
    },

    onLegend_grid_column_avgBoxReady: function(component, width, height, eOpts) {
        var cmp = Ext.getCmp('advanced_futuretrend');
        if (cmp && cmp.checked) {
            component.hide();
        } else {
            component.show();
        }
    },

    onLegend_grid_column_perc95BoxReady: function(component, width, height, eOpts) {
        var cmp = Ext.getCmp('advanced_futuretrend');
        if (cmp && cmp.checked) {
            component.hide();
        } else {
            component.show();
        }
    },

    onLegend_grid_column_lastBoxReady: function(component, width, height, eOpts) {
        var cmp = Ext.getCmp('advanced_futuretrend');
        if (cmp && cmp.checked) {
            component.hide();
        } else {
            component.show();
        }
    },

    onLegend_grid_column_futuretrendBoxReady: function(component, width, height, eOpts) {
        var cmp = Ext.getCmp('advanced_futuretrend');
        if (cmp && cmp.checked) {
            component.show();
        } else {
            component.hide();
        }
    },

    onLegend_gridAfterRender: function(component, eOpts) {
        Ext.getCmp('legends_minimize').hide();
    }

});
