/*
 * File: app/view/PeriodWindow.js
 *
 * This file was generated by Sencha Architect version 4.2.4.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Reports.view.PeriodWindow', {
    extend: 'Ext.window.Window',

    requires: [
        'Ext.form.Panel',
        'Ext.form.FieldContainer',
        'Ext.form.field.Number',
        'Ext.form.field.Date',
        'Ext.form.field.Time',
        'Ext.toolbar.Toolbar',
        'Ext.toolbar.Spacer',
        'Ext.button.Button'
    ],

    autoShow: true,
    height: 160,
    hidden: false,
    id: 'period_window',
    width: 270,
    title: Ext.locale.translate('Period'),
    modal: true,

    layout: {
        type: 'vbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'form',
                    id: 'period_form_container_window',
                    layout: 'auto',
                    bodyPadding: '15 12',
                    items: [
                        {
                            xtype: 'container',
                            layout: {
                                type: 'vbox',
                                align: 'stretch'
                            },
                            items: [
                                {
                                    xtype: 'fieldcontainer',
                                    hidden: true,
                                    id: 'period_last_report',
                                    margin: '0 0 5 5',
                                    width: 200,
                                    fieldLabel: Ext.locale.translate('Last'),
                                    labelWidth: 50,
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretchmax'
                                    },
                                    items: [
                                        {
                                            xtype: 'numberfield',
                                            id: 'period_last_number_report',
                                            margin: '0 5 0 0',
                                            width: 65,
                                            fieldLabel: '',
                                            name: 'timeCounter',
                                            value: 1,
                                            maxValue: 365,
                                            minValue: 1
                                        },
                                        {
                                            xtype: 'combobox',
                                            flex: 1,
                                            frame: false,
                                            id: 'period_last_type_report',
                                            fieldLabel: '',
                                            name: 'timeUnit',
                                            value: 'days',
                                            editable: false,
                                            displayField: 'name',
                                            queryMode: 'local',
                                            store: 'period_last_types',
                                            valueField: 'value'
                                        }
                                    ]
                                },
                                {
                                    xtype: 'fieldcontainer',
                                    id: 'period_from_report',
                                    margin: '0 0 5 5',
                                    width: 250,
                                    fieldLabel: Ext.locale.translate('From'),
                                    hideEmptyLabel: false,
                                    labelWidth: 40,
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretchmax'
                                    },
                                    items: [
                                        {
                                            xtype: 'datefield',
                                            id: 'period_from_date_report',
                                            margin: '0 5 0 0',
                                            width: 110,
                                            fieldLabel: '',
                                            name: 'dateFrom',
                                            allowBlank: false,
                                            format: 'd-m-Y',
                                            listeners: {
                                                afterrender: {
                                                    fn: me.onPeriod_from_date_reportAfterRender,
                                                    scope: me
                                                }
                                            }
                                        },
                                        {
                                            xtype: 'timefield',
                                            id: 'period_from_time_report',
                                            width: 70,
                                            fieldLabel: '',
                                            name: 'timeFrom',
                                            value: '00:00',
                                            allowBlank: false,
                                            matchFieldWidth: false,
                                            format: 'H:i'
                                        }
                                    ]
                                },
                                {
                                    xtype: 'fieldcontainer',
                                    flex: 1,
                                    id: 'period_to_report',
                                    margin: '0 0 5 5',
                                    width: 250,
                                    fieldLabel: Ext.locale.translate('To'),
                                    labelWidth: 35,
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretchmax',
                                        padding: '0 0 10 5'
                                    },
                                    items: [
                                        {
                                            xtype: 'datefield',
                                            cls: 'date-time-constrains',
                                            id: 'period_to_date_report',
                                            margin: '0 5 0 0',
                                            width: 110,
                                            fieldLabel: '',
                                            name: 'dateTo',
                                            allowBlank: false,
                                            format: 'd-m-Y',
                                            listeners: {
                                                afterrender: {
                                                    fn: me.onPeriod_to_date_reportAfterRender,
                                                    scope: me
                                                }
                                            }
                                        },
                                        {
                                            xtype: 'timefield',
                                            id: 'period_to_time_report',
                                            width: 70,
                                            fieldLabel: '',
                                            name: 'timeTo',
                                            value: '23:59',
                                            allowBlank: false,
                                            matchFieldWidth: false,
                                            format: 'H:i'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ],
            dockedItems: [
                {
                    xtype: 'toolbar',
                    flex: 1,
                    dock: 'bottom',
                    items: [
                        {
                            xtype: 'tbspacer',
                            flex: 1
                        },
                        {
                            xtype: 'button',
                            handler: function(button, e) {
                                this.up('window').close();
                            },
                            text: Ext.locale.translate('Cancel')
                        },
                        {
                            xtype: 'container',
                            items: [
                                {
                                    xtype: 'button',
                                    handler: function(button, e) {
                                        this.up('window').close();
                                    },
                                    id: 'report_period_submit',
                                    text: Ext.locale.translate('Submit')
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onPeriod_from_date_reportAfterRender: function(component, eOpts) {
        if (!component.getValue()) {
            component.setValue(new Date());
        }
    },

    onPeriod_to_date_reportAfterRender: function(component, eOpts) {
        if (!component.getValue()) {
            component.setValue(new Date());
        }
    }

});