/*
 * File: app/view/SaveReport.js
 *
 * This file was generated by Sencha Architect version 4.2.4.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Reports.view.SaveReport', {
    extend: 'Ext.window.Window',
    alias: 'widget.save_report_popup',

    requires: [
        'Ext.form.Panel',
        'Ext.form.field.Text',
        'Ext.form.field.Checkbox',
        'Ext.toolbar.Toolbar',
        'Ext.toolbar.Spacer',
        'Ext.button.Button'
    ],

    height: 185,
    width: 350,
    title: Ext.locale.translate('Save the Report'),

    layout: {
        type: 'vbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            dockedItems: [
                {
                    xtype: 'form',
                    flex: 1,
                    dock: 'top',
                    margin: 0,
                    bodyPadding: 15,
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'textfield',
                            validator: function(value) {
                                var isItemInStore = (Ext.getStore('saved_reports').findExact('name', value) >= 0);

                                if (isItemInStore) {
                                    this.focus();
                                    Ext.getCmp('save_report_form_ok').setDisabled(true);
                                    return Ext.locale.translate('A report with that name already exists!');
                                }

                                Ext.getCmp('save_report_form_ok').setDisabled(false);
                                return true;
                            },
                            flex: 1,
                            margins: '',
                            fieldLabel: Ext.locale.translate('Please enter a new report name:'),
                            labelAlign: 'top',
                            name: 'report_name',
                            allowBlank: false,
                            allowOnlyWhitespace: false,
                            vtype: 'alphanum'
                        },
                        {
                            xtype: 'checkboxfield',
                            flex: 1,
                            fieldLabel: '',
                            labelAlign: 'top',
                            name: 'allow_all',
                            boxLabel: Ext.locale.translate('All May View'),
                            inputValue: '1',
                            uncheckedValue: '0'
                        }
                    ],
                    dockedItems: [
                        {
                            xtype: 'toolbar',
                            flex: 1,
                            dock: 'bottom',
                            autoScroll: true,
                            items: [
                                {
                                    xtype: 'tbspacer',
                                    flex: 1
                                },
                                {
                                    xtype: 'button',
                                    minWidth: 80,
                                    width: '',
                                    text: Ext.locale.translate('Cancel'),
                                    listeners: {
                                        click: {
                                            fn: me.onCancelClick,
                                            single: true,
                                            scope: me
                                        }
                                    }
                                },
                                {
                                    xtype: 'container',
                                    items: [
                                        {
                                            xtype: 'button',
                                            id: 'save_report_form_ok',
                                            minWidth: 80,
                                            text: Ext.locale.translate('OK')
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onCancelClick: function(button, e, eOpts) {
        button.up('window').destroy();
    }

});